/****************************************************************************/
/* T  vF SDJ[hhCoŔG[R[h							*/
/*   F																	*/
/* 쐬F 2011.09.11														*/
/* XVF 2013.09.30														*/
/* Copyright    resove														*/
/****************************************************************************/
#ifndef DRV_ERR_CODE_H
#define DRV_ERR_CODE_H

#define SD_OK							( 0x0000 )	/* G[	*/

#define SD_ERR_CMD_TIMEOUT				( 0x0001 )	/* R}h^CAEg	*/

/* ֘A */
#define SD_ERR_INIT_RESET_TIMEOUT		( 0x0011 )	/* Zbg^CAEg	*/
#define SD_ERR_INIT_INIT_TIMEOUT		( 0x0012 )	/* CjVCY^CAEg	*/

/* ݊֘A */
#define SD_ERR_WRITE					( 0x0020 )	/* ݃G[			*/
#define SD_ERR_WRITE_IN_IDLE_STATE		( 0x0021 )	/* R1 X|X */
#define SD_ERR_WRITE_ERASE_RESET		( 0x0022 ) 	/* R1 X|X */
#define SD_ERR_WRITE_ILLEGAL_COMMAND	( 0x0023 )	/* R1 X|X */
#define SD_ERR_WRITE_COM_CRC_ERROR		( 0x0024 )	/* R1 X|X */
#define SD_ERR_WRITE_ERASE_SEQ_ERROR 	( 0x0025 )	/* R1 X|X */
#define SD_ERR_WRITE_ADDRESS_ERROR		( 0x0026 )	/* R1 X|X */
#define SD_ERR_WRITE_PARAMETER_ERROR	( 0x0027 )	/* R1 X|X */
#define SD_ERR_WRITE_TIMEOUT			( 0x0028 )	/* ݃^CAEg	*/
#define SD_ERR_WRITE_RESPONSE_TIMEOUT	( 0x0029 )	/* X|XM^CAEg	*/
#define SD_ERR_WRITE_CRC_ERR			( 0x002a )	/* ݎ CRC G[	*/
#define SD_ERR_WRITE_PHYSICAL			( 0x002b )	/* ݕIȃG[	*/
#define SD_ERR_WRITE_OTHER				( 0x002c )	/* ݗRsȃG[	*/

/* ǂݍ݊֘A */
#define SD_ERR_READ						( 0x0030 )	/* BLOCK READ G[		*/
#define SD_ERR_READ_IN_IDLE_STATE		( 0x0031 )	/* R1 X|X */
#define SD_ERR_READ_ERASE_RESET			( 0x0032 ) 	/* R1 X|X */
#define SD_ERR_READ_ILLEGAL_COMMAND		( 0x0033 )	/* R1 X|X */
#define SD_ERR_READ_COM_CRC_ERROR		( 0x0034 )	/* R1 X|X */
#define SD_ERR_READ_ERASE_SEQ_ERROR 	( 0x0035 )	/* R1 X|X */
#define SD_ERR_READ_ADDRESS_ERROR		( 0x0036 )	/* R1 X|X */
#define SD_ERR_READ_PARAMETER_ERROR		( 0x0037 )	/* R1 X|X */
#define SD_ERR_READ_DATA_RCV_TIMEOUT	( 0x0038 )	/* f[^M^CAEg	*/
#define SD_ERR_READ_RESPONSE_TIMEOUT	( 0x0039 )	/* X|XM^CAEg	*/
#define SD_ERR_READ_TOKEN_RCV_TIMEOUT	( 0x003a )	/* g[NM^CAEg */

/* CSD ANZX֘A */
#define SD_ERR_CSD						( 0x0040 )	/* CSD 擾G[		*/
#define SD_ERR_CSD_IN_IDLE_STATE		( 0x0041 )	/* R1 X|X */
#define SD_ERR_CSD_ERASE_RESET			( 0x0042 ) 	/* R1 X|X */
#define SD_ERR_CSD_ILLEGAL_COMMAND		( 0x0043 )	/* R1 X|X */
#define SD_ERR_CSD_COM_CRC_ERROR		( 0x0044 )	/* R1 X|X */
#define SD_ERR_CSD_ERASE_SEQ_ERROR		( 0x0045 )	/* R1 X|X */
#define SD_ERR_CSD_ADDRESS_ERROR		( 0x0046 )	/* R1 X|X */
#define SD_ERR_CSD_PARAMETER_ERROR		( 0x0047 )	/* R1 X|X */
#define SD_ERR_CSD_DATA_RCV_TIMEOUT		( 0x0048 )	/* f[^M^CAEg	*/
#define SD_ERR_CSD_RESPONSE_TIMEOUT		( 0x0049 )	/* X|XM^CAEg	*/
#define SD_ERR_CSD_TOKEN_RCV_TIMEOUT	( 0x004a )	/* g[NM^CAEg */
#define SD_ERR_CSD_CHECK_BIT			( 0x004b )	/* CSD eG[		*/

/* CID ANZX֘A */
#define SD_ERR_CID						( 0x0050 )	/* CID 擾G[		*/
#define SD_ERR_CID_IN_IDLE_STATE		( 0x0051 )	/* R1 X|X */
#define SD_ERR_CID_ERASE_RESET			( 0x0052 ) 	/* R1 X|X */
#define SD_ERR_CID_ILLEGAL_COMMAND		( 0x0053 )	/* R1 X|X */
#define SD_ERR_CID_COM_CRC_ERROR		( 0x0054 )	/* R1 X|X */
#define SD_ERR_CID_ERASE_SEQ_ERROR		( 0x0055 )	/* R1 X|X */
#define SD_ERR_CID_ADDRESS_ERROR		( 0x0056 )	/* R1 X|X */
#define SD_ERR_CID_PARAMETER_ERROR		( 0x0057 )	/* R1 X|X */
#define SD_ERR_CID_DATA_RCV_TIMEOUT		( 0x0058 )	/* f[^M^CAEg	*/
#define SD_ERR_CID_RESPONSE_TIMEOUT		( 0x0059 )	/* X|XM^CAEg	*/
#define SD_ERR_CID_TOKEN_RCV_TIMEOUT	( 0x005a )	/* g[NM^CAEg */
#define SD_ERR_CID_CHECK_BIT			( 0x005b )	/* CID eG[		*/

/* OCR ANZX֘A */
#define SD_ERR_OCR						( 0x0060 )	/* CID 擾G[		*/
#define SD_ERR_OCR_IN_IDLE_STATE		( 0x0061 )	/* R1 X|X */
#define SD_ERR_OCR_ERASE_RESET			( 0x0062 ) 	/* R1 X|X */
#define SD_ERR_OCR_ILLEGAL_COMMAND		( 0x0063 )	/* R1 X|X */
#define SD_ERR_OCR_COM_CRC_ERROR		( 0x0064 )	/* R1 X|X */
#define SD_ERR_OCR_ERASE_SEQ_ERROR		( 0x0065 )	/* R1 X|X */
#define SD_ERR_OCR_ADDRESS_ERROR		( 0x0066 )	/* R1 X|X */
#define SD_ERR_OCR_PARAMETER_ERROR		( 0x0067 )	/* R1 X|X */
#define SD_ERR_OCR_DATA_RCV_TIMEOUT		( 0x0068 )	/* f[^M^CAEg	*/
#define SD_ERR_OCR_RESPONSE_TIMEOUT		( 0x0069 )	/* X|XM^CAEg	*/
#define SD_ERR_OCR_TOKEN_RCV_TIMEOUT	( 0x006a )	/* g[NM^CAEg */

/* v֘A */
#define SD_ERR_REQ_ADDRESS				( 0x0070 )	/* AhXvG[		*/
#define SD_ERR_REQ_LEN					( 0x0071 )	/* w̌	*/
#define SD_ERR_DRV_INITIAL				( 0x0073 )	/* ĂȂ		*/
#define SD_ERR_OVER_BOARDER				( 0x0074 )	/* E܂v			*/

#define SD_ERR_CHENGE_BLOCK_SIZE		( 0x0081 )	/* ubNTCYύXs	*/

#endif	/* DRV_ERR_CODE_H */
