/****************************************************************************/
/* T  vF whCoƂ̃C^tF[X`							*/
/*   F 																*/
/* 쐬F 2004.09.11														*/
/* XVF 2013.12.29														*/
/* Copyright F	resove														*/
/****************************************************************************/
#ifndef RF_DRIVER_INTERFACE_H
#define RF_DRIVER_INTERFACE_H

#ifndef	TRUE
#define TRUE	( 1 )
#endif
#ifndef	FALSE
#define FALSE	( 0 )
#endif

#ifndef	NULL
#define NULL	((void*) 0L )
#endif


typedef struct t_rf_drv_ver {
	unsigned short ver;									/* hCoo[W */
	const char * type;									/* hCo^Cv */
} T_RF_DRV_VER;

/* hCoC^tF[X */
typedef struct s_rf_driver_interface 
{
	unsigned short (*initialize)( void );			/* hCȍ	*/
	unsigned short (*write)(						/*  */
							unsigned long addr,
							char * buff,
							unsigned short len );
	unsigned short (*writePoll)(					/* ݂̐i|[O	*/
							unsigned short * len );
	unsigned short (*fill)(							/* PubN𓯈f[^Ŗ */
							unsigned long address,
							char writeData );	
	unsigned short	(*read)(						/* ǂݎN	*/
							unsigned long addr,
							char * buff,
							unsigned short len );
	unsigned short (*readPoll)(						/* ǂݎ̐i|[O	*/
							unsigned short * len );
	unsigned short (*getBlockSize)( void );			/* ubNTCY擾	*/
	unsigned long  (*getCapacity)( void );			/* Seʂ̎擾		*/
	unsigned short (*conclude)( void );				/* gp̏I	*/
	void		   (*getVer)( T_RF_DRV_VER * ver );	/* o[W擾	*/
						
} T_RF_DRIVER_INTERFACE;

/****************************************************************************/
/* hCo֐̒`														*/
/****************************************************************************/
extern const T_RF_DRIVER_INTERFACE rfDriverInterface;

#define drvInitialize	(*(rfDriverInterface.initialize))
#define drvWrite		(*(rfDriverInterface.write))
#define drvWritePoll	(*(rfDriverInterface.writePoll))
#define drvFill			(*(rfDriverInterface.fill))
#define drvRead			(*(rfDriverInterface.read))
#define drvReadPoll		(*(rfDriverInterface.readPoll))
#define drvGetBlockSize	(*(rfDriverInterface.getBlockSize))
#define drvGetCapacity	(*(rfDriverInterface.getCapacity))
#define drvGetVer		(*(rfDriverInterface.getVer))
#define drvConclude		(*(rfDriverInterface.conclude))


#endif	/* #ifndef RF_DRIVER_INTERFACE_H */
