/****************************************************************************/
/* T  vF t@CVXe tH[}bg									*/
/*   F 																*/
/* 쐬F 2005.07.23														*/
/* XVF 2009.01.04														*/
/* Copyright F	resove														*/
/****************************************************************************/
#include "RfInterface.h"
#include "RfMiddle.h"
#include "RfFormat.h"
#include "RfDiskLayout.h"

/* tH[}bgvZʕۑ̈ */
/*  format ɌvZʂۑĂ									*/
/*  checkParm()łقƂǂ̒lvZ										*/
/*																			*/
/*  EbpbAddr  BPB ̈ʒuAhXŎ									*/
/*  EfatSector																*/
/*     1 FAT ̃ZN^														*/
/*  EclustNum																*/
/*     NX^															*/

typedef struct t_rf_format_calc_temp
{
	unsigned long	driveSector;				/* hCȗSZN^		*/
	unsigned long	partitionSector;			/* p[eBV̑SZN^*/
	unsigned long	bpbAddr;					/* BPB ʒu					*/
	unsigned long	fat1Point;					/* FAT1 ̃AhX			*/
	unsigned long	fat2Point;					/* FAT2 ̃AhX			*/
	unsigned short	fatSector;					/* FAT ̃ZN^			*/
	unsigned long	rootPoint;					/* ROOTfBNg̃AhX*/
	unsigned short	rootSector;					/* ROOTfBNg̃ZN^*/
	unsigned long	dataPoint;					/* f[^̈̃AhX		*/
	unsigned short	clustNum;					/* NX^				*/
	char			fSystem;					/* t@CVXe FAT12/FAT16	*/
} T_RF_FORMAT_CALC_TEMP;

/* tH[}bg */
/*    bpbSector   BPB ʒuݒ肷Ƃ makeMbr  1 ɂȂ΂ȂB*/
/*  EresSector  BPB  FAT ܂ł̃ZN^B 1 i[Ă BPB 	*/
/*     ̎̃ZN^ FAT n܂Ă鎖킷B						*/
/*  EsectPerClust 1 NX^̃ZN^킷B Qׂ̂ 128 ܂Őݒ	*/
/*     \B																	*/
/*  EmakeMbr  MBR 邩̃tOB									*/
/*      0 ݒ肵Ƃ MBR Ȃ̂ BPB ̈ʒu͕ύXȂB		*/
/*      ̂Ƃ bpbSector ͖B										*/
/*  EclearClust  1 ɂƃNX^ׂ̈ăNAB					*/
/*     Ԃ̂ŒӁII													*/
typedef struct t_rf_format_info
{
	T_RF_FORMAT_CALC_TEMP	tmp;				/* vZrŎgpl		*/
	unsigned short	option;						/* w肳ꂽIvV		*/
	unsigned long	bpbSector;					/* BPB ʒu(ZN^)			*/
	unsigned short	resSector;					/* BPB  FAT ̑ΓIȈʒu	*/
	unsigned short	bytesPerSector;				/* 1ZN^̃oCg		*/
	unsigned char	sectPerClust;				/* PNX^̃ZN^		*/
	unsigned char	makeMbr:1;					/* MBR 쐬敪				*/
	unsigned char	makeBpb:1;					/* BPB 쐬敪				*/
	unsigned char	clearClust:1;				/* NX^̈̃NA		*/
} T_RF_FORMAT_INFO;


/****************************************************************************/
/* Oϐ																	*/
/****************************************************************************/

/****************************************************************************/
/* ϐ																	*/
/****************************************************************************/
#define OPT_BPB_MASK	( 0x00ff )						/* BPB ʒu			*/

/****************************************************************************/
/* ֐																	*/
/****************************************************************************/
static unsigned short execFormat( T_RF_FORMAT_INFO * pFormatInfo );/* farmat s	*/
static unsigned short makeMbr( T_RF_FORMAT_INFO * formatInfo );	/* MBR 쐬		*/
static unsigned short makeBpb( T_RF_FORMAT_INFO * formatInfo );	/* BPB 쐬		*/
static unsigned short makeFat( T_RF_FORMAT_INFO * formatInfo );	/* FAT 쐬		*/
static unsigned short makeRoot( T_RF_FORMAT_INFO * formatInfo );	/* ROOTfBNg쐬		*/
static unsigned short clearCluster( T_RF_FORMAT_INFO * pFormatInfo );	/* NX^NA	*/

static unsigned short checkParm( T_RF_FORMAT_INFO * pFormatInfo );	/* IvV`FbN */
static unsigned short checkParmDos( T_RF_FORMAT_INFO * pFormatInfo,
							 T_RF_DRIVE_INFO * pDrvInfo );	/* DOS ̃IvV`FbN */
static unsigned short checkParmMainte( T_RF_FORMAT_INFO * pFormatInfo,
								T_RF_DRIVE_INFO * pDrvInfo );	/* Ɠ̃IvV`FbN */
static unsigned short checkParmSd( T_RF_FORMAT_INFO * pFormatInfo,
							T_RF_DRIVE_INFO * pDrvInfo );	/* SD J[h̃IvV`FbN */
static unsigned short calcBpbSectByDataPoint( T_RF_FORMAT_INFO * pFormatInfo);/* f[^ʒu BPB ʒu߂ */
static unsigned short updateCalcInfo( T_RF_FORMAT_INFO * formatInfo ); /* vZKv formatInfo */
static unsigned long clustNum( T_RF_FORMAT_INFO * formatInfo );	/* NX^vZ	*/
static unsigned long tailRemain( T_RF_FORMAT_INFO * pFormatInfo );	/* ZN^̗]vZ */
static void getDosClusterSize( T_RF_FORMAT_INFO * pFormatInfo );	/* DOS ̃NX^TCY߂ */
static void getSdDataPoint( T_RF_FORMAT_INFO * pFormatInfo );	/* SD `̃f[^Jnʒu߂ */

/****************************************************************************/
/* T  v																	*/
/*        tH[}bg̃AvP[VC^tF[X						*/
/* p[^																*/
/*        optionFtH[}bg̃IvV									*/
/*                RF_FORMAT_MODE_DOS  FDOSWFPNX^ 8 ZN^		*/
/*                RF_FORMAT_MODE_SD   FSDJ[hWFPNX^ 32 ZN^A*/
/*                                      BPB ʒuύX					*/
/*                RF_FORMAT_MODE_MAINTFƓtH[}bgB			*/
/*                RF_FORMAT_OPT_MBR   FMBR Vɍ쐬				*/
/*                RF_FORMAT_OPT_CLEAR Fgp̈NA				*/
/*                  ̃IvV͏ʂPoCgɊi[BBPB ̈	*/
/*                uύXꍇ͉ʂPoCg BPB ̃ZN^ʒuݒ	*/
/*                BZN^ʒu 1 ` 0xff ܂Ŏw\B				*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        BPB ̈ʒuANX^TCYAFAT ̈ʒuȂǂ肷B			*/
/****************************************************************************/
unsigned short RfFormat( unsigned short option )
{
	T_RF_FCB * pFcb = (T_RF_FCB*)0;
	T_RF_FORMAT_INFO	formatInfo;						/* tH[}bg		*/
	unsigned short err = RF_OK;							/* G[R[h			*/

	pFcb = RfmFindUseFcb();
	if( pFcb != (T_RF_FCB*)0 )
	{
		err = RF_ERR_FMT_THERE_IS_OPENED;			/* I[ṽt@C */
		goto ERR_EXIT;
	}

	/* tH[}bgs	*/
	formatInfo.option = option;						/* IvVۑ		*/
	err = checkParm( &formatInfo );					/* IvV`FbN		*/
	if( err != RF_OK ) 		goto ERR_EXIT;
	err = updateCalcInfo( &formatInfo );			/* FAT TCYvZ	*/
	if( err != RF_OK ) 		goto ERR_EXIT;
	err = execFormat( &formatInfo );				/* tH[}bgs		*/
	if( err != RF_OK ) 		goto ERR_EXIT;
	err = RfInitFileSystem();						/* foCXXV	*/

ERR_EXIT:
	return err;
}


/****************************************************************************/
/* T  v																	*/
/*        tH[}bg̎s												*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        IvV`FbNZN^TCYABPBʒuȂǂ߂B			*/
/*        RfmGetDriveInfo()͏r[łǂ̂ŃG[͌ȂB	*/
/*        Ǎ㏉Ă͈͂`FbNWX^ǂ߂Ă	*/
/*        ΌpB													*/
/****************************************************************************/
unsigned short checkParm( T_RF_FORMAT_INFO * pFormatInfo )
{
	T_RF_DRIVE_INFO driveInfo;							/* hCu		*/
	unsigned short err = RF_OK;							/* G[R[h			*/

	err = RfmGetDriveInfo( &driveInfo );				/* hCu擾	*/
	if( err != RF_OK )						goto ERR_EXIT;
	if( driveInfo.drvInit == 0 )
	{
		err = RF_ERR_FMT_INIT_FAIL;
		goto ERR_EXIT;									/* s		*/
	}

	/* hCo@\̃`FbN */
	if( rfDriverInterface.fill == NULL )
	{
		err = RF_ERR_DEFINE_DRIVER;
		goto ERR_EXIT;
	}

	pFormatInfo->bytesPerSector
						 = driveInfo.bytesPerSector;	/* 1 ZN^̃oCg	*/

	pFormatInfo->tmp.driveSector =
		driveInfo.cardSize /
		(unsigned long)driveInfo.bytesPerSector;		/* hCȗZN^	*/

	if( ( pFormatInfo->option & RF_FORMAT_MODE_DOS ) != 0 )
	{
		/* DOS ̃p[^`FbN */
		err = checkParmDos( pFormatInfo, &driveInfo );
		if( err != RF_OK )					goto ERR_EXIT;
	}
	else if( ( pFormatInfo->option & RF_FORMAT_MODE_SD ) !=  0 )
	{
		/* SD J[h̃p[^`FbN */
		err = checkParmSd( pFormatInfo, &driveInfo );
		if( err != RF_OK )					goto ERR_EXIT;
	}
	else
	{
		/* Ɠ̃tH[}bg */
		err = checkParmMainte( pFormatInfo, &driveInfo );
		if( err != RF_OK )					goto ERR_EXIT;
	}

	/* NX^̈NA敪	*/
	pFormatInfo->clearClust = FALSE;
	if( ( pFormatInfo->option & RF_FORMAT_OPT_CLEAR ) != 0 )
	{
		pFormatInfo->clearClust = TRUE;					/* NA			*/
	}

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        DOS ̃p[^`FbN									*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*         DOS ł͐ BPB ʒu߂ĂvZB					*/
/****************************************************************************/
unsigned short checkParmDos( T_RF_FORMAT_INFO * pFormatInfo, T_RF_DRIVE_INFO * pDrvInfo )
{
	unsigned short err = RF_OK;


	if( (pFormatInfo->option & 0x00ff) == RF_FORMAT_OPT_SAME_PARTITION )
	{
		/* BSR ̈ʒu͕ύXȂ */
		if( pDrvInfo->mbrInit == FALSE )			/* MBR ̏sĂ */
		{
			/* MBR ̂Ő擪 BSR  */
			pFormatInfo->bpbSector = 0;
		}
		else
		{
			pFormatInfo->bpbSector = pDrvInfo->bpbSector;
		}
		pFormatInfo->makeMbr = FALSE;				/* BPB ύX̂ MBR ͍Ȃ	*/
	}
	else
	{
		if( (pFormatInfo->option & 0x00ff) == 0 )
		{
			/* BPB  0 ZN^̏ꍇ͐擪 BSR 
				zû MBR ͍Ȃ */
			pFormatInfo->makeMbr = FALSE;
		}
		else
		{
			pFormatInfo->makeMbr = TRUE;				/* BPB ʒuύX̂ MBR 		*/
		}
		pFormatInfo->bpbSector =
				 (unsigned long)(pFormatInfo->option & 0x00ff);	/* IvVŎw肳ꂽ̂gp */
	}
	/* getDosClusterSize()ŕKvȂ̂ŐɃp[eBṼZN^vZ */
	pFormatInfo->tmp.partitionSector = 
		pFormatInfo->tmp.driveSector - pFormatInfo->bpbSector;
	getDosClusterSize( pFormatInfo );					/* NX^TCYvZ		*/
	pFormatInfo->resSector = 1;							/* U[uZN^Ȃ		*/
	pFormatInfo->makeBpb = TRUE;						/* BPB ύX			*/

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        SDJ[h̃p[^`FbN								*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*         SDJ[hł̓f[^Jnʒu߂Ă BPB ̈ʒutZB*/
/*         NX^TCY͏ 32  64 sector/cluster ƂȂB			*/
/****************************************************************************/
unsigned short checkParmSd( T_RF_FORMAT_INFO * pFormatInfo, T_RF_DRIVE_INFO * pDrvInfo )
{
	unsigned short err = RF_OK;

	/* SD J[h`tH[}bg	*/
	pFormatInfo->resSector = 1;						/* U[uZN^Ȃ		*/
	pFormatInfo->makeMbr = TRUE;					/*  MBR 		*/
	pFormatInfo->makeBpb = TRUE;					/*  BPB 		*/

	pFormatInfo->sectPerClust = 32;					/* 32 sector/cluster	*/
	if( pFormatInfo->tmp.driveSector > 1024UL * 1024UL * 1024UL / 512UL )
	{
		/* 1G byte 𒴂̂ 64 sector/cluster */
		pFormatInfo->sectPerClust = 64;					/* 64 sector/cluster	*/
	}
	getSdDataPoint( pFormatInfo );					/* f[^Jnʒu߂	*/

	if( calcBpbSectByDataPoint( pFormatInfo ) == FALSE )	/* BPB ʒuvZ */
	{
		err = RF_ERR_FMT_INIT_FAIL;
	}
	else
	{
		pFormatInfo->tmp.partitionSector = 			/* p[eBṼZN^ */
			pFormatInfo->tmp.driveSector - pFormatInfo->bpbSector;
		/* eʂ̃`FbN */
		if( pFormatInfo->tmp.partitionSector >  ((unsigned long)RF_F_CLUST_FAT16_MAX - 1UL)* (unsigned long)pFormatInfo->sectPerClust )
		{
			err = RF_ERR_FMT_OVER_SIZE;
		}
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        Ɠ̃p[^`FbN								*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*         ƓtH[}bgȂ̂ MBR, BPB ǂ߂ĂȂ΂Ȃ	*/
/*        BMBR, BPB ͍XVȂB										*/
/****************************************************************************/
unsigned short checkParmMainte( T_RF_FORMAT_INFO * pFormatInfo, T_RF_DRIVE_INFO * pDrvInfo )
{
	unsigned short err = RF_ERR_FMT_INIT_FAIL;

	if( pDrvInfo->bpbInit != FALSE )
	{
		/* ƓtH[}bg */
		pFormatInfo->bpbSector = pDrvInfo->bpbSector;	/* BPB ʒu		*/
		pFormatInfo->sectPerClust =
					 pDrvInfo->sectorPerCluster;		/* sector/cluster	*/
		pFormatInfo->resSector =
					(unsigned short)					/* ̃U[uZN^	*/
					( pDrvInfo->fatPoint /(unsigned long)pDrvInfo->bytesPerSector - pDrvInfo->bpbSector);
		pFormatInfo->makeMbr = FALSE;					/* ύX̂ MBR Ȃ*/
		pFormatInfo->makeBpb = FALSE;					/* ύX̂ BPB Ȃ*/
		pFormatInfo->tmp.partitionSector = 				/* p[eBṼZN^ */
			pFormatInfo->tmp.driveSector - pFormatInfo->bpbSector;
		err = RF_OK;
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        DOS ̏ꍇ̃NX^TCYvZ								*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        DOS Ƃ͌Ȃ犮SDOS ł̌`Ă킯ł͂	*/
/*       BBPB  FAT ̊Ԃɋ󂫃ZN^Ƃ邪̖@͂	*/
/*       ĂȂB̂BPB  FAT ̊Ԃreserve sector ͎Ă	*/
/*       B																*/
/*        DOS ł͂ȂׂNX^Ȃ悤ɃNX^TCY	*/
/*       B															*/
/*        DOS ̗_̓fBXŇԂȂȂ̂ŃfBXNeʂL	*/
/*       Ɏgp邱ƂłB_ FAT ւ̃ANZXpɂɔ邽	*/
/*       ߓǂݏ̑xxȂ邱ƁBhCũTCY傫ȂƃN	*/
/*       X^TCY傫Ȃ邽߂̌_ĂB				*/
/*        ȂׂNX^TCYȂ悤ɒ邪 16MB 	*/
/*       eʃfBXN̏ꍇ 8 ZN^ƂB16MB ̏ꍇ FAT12 	*/
/*       ƂȂB															*/
/*        Ⴆ 128MB ̃fBXN̏ꍇ̓fBXN̗̂eʂ 128MB ɖ	*/
/*       Ȃ̂ 4 sector/cluster ƂȂB								*/
/*        1 ZN^ 512 oCgȊO͍lÂ炢ꂵłȂ̂sւ	*/
/*       ̂ 512 oCg/1ZN^ ōlĂăZN^ɒ悤ɎB	*/
/****************************************************************************/
void getDosClusterSize( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned short tableSize;							/* e[ũR[h	*/
	unsigned short i;
	const static struct t_totalsect_vs_clust_size 
	{
		unsigned long	totalSize;						/* p[eBṼZN^	*/
		unsigned char	clusterSize;					/* 1 NX^̃ZN^	*/
	} clustTbl[] = 
	{
		{2048UL*1024UL*1024UL/512UL, (unsigned char)128 },	/*2048MB ȏ128 ZN^(64koCg)	*/
		{1024UL*1024UL*1024UL/512UL, (unsigned char) 64 },	/*1024MB ȏ 64 ZN^(32koCg)	*/
		{ 512UL*1024UL*1024UL/512UL, (unsigned char) 32 },	/* 512MB ȏ 32 ZN^(16koCg)	*/
		{ 256UL*1024UL*1024UL/512UL, (unsigned char) 16 },	/* 256MB ȏ 16 ZN^( 8koCg)	*/
		{ 128UL*1024UL*1024UL/512UL, (unsigned char)  8 },	/* 128MB ȏ  8 ZN^( 4koCg)	*/
		{  64UL*1024UL*1024UL/512UL, (unsigned char)  4 },	/*  64MB ȏ  4 ZN^( 2koCg)	*/
		{  32UL*1024UL*1024UL/512UL, (unsigned char)  2 },	/*  32MB ȏ  2 ZN^( 1koCg)	*/
		{  16UL*1024UL*1024UL/512UL, (unsigned char)  1 },	/*  16MB ȏ  1 ZN^(512oCg)	*/
		{   0UL*1024UL*1024UL/512UL, (unsigned char)  8 }	/*  16MB   8 ZN^( 4koCg)	*/
	};
	tableSize = (unsigned short)(sizeof(clustTbl)/sizeof(struct t_totalsect_vs_clust_size));

	pFormatInfo->sectPerClust = 8;						/* ftHg̃NX^TCY	*/
	for( i = 0; i < tableSize; ++i )
	{
		if( clustTbl[i].totalSize < pFormatInfo->tmp.partitionSector ) 
		{
			pFormatInfo->sectPerClust = clustTbl[i].clusterSize;
			break;
		}
	}
}

/****************************************************************************/
/* T  v																	*/
/*        SD`̏ꍇ̃f[^Jnʒu߂								*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        SD `ł̓fBXNTCYɂf[^Jnʒu܂B	*/
/*        BPB ̈ʒutZB											*/
/*        ̊֐ł̓fBXNTCYf[^Jnʒu߂B			*/
/*        1 ZN^ 512 oCgȊO͍lÂ炢ꂵłȂ̂sւ	*/
/*       ̂ 512 oCg = 1ZN^ ōlĂăZN^ɒ悤ɎB	*/
/*       ZN^ωႵĕωB								*/
/****************************************************************************/
void getSdDataPoint( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned short tableSize;							/* e[ũR[h	*/
	unsigned short i;
	const static struct t_total_sect_vs_data_point
	{
		unsigned long	totalSize;						/* p[eBṼZN^	*/
		unsigned long	dataPoint;						/* f[^Jnʒu		*/
	} clustTbl[] = 
	{
		{2048UL*1024UL*1024UL/512UL, 0x60000UL/512UL },	/*2048MB ȏ 	*/
		{1024UL*1024UL*1024UL/512UL, 0x60000UL/512UL },	/*1024MB ȏ 	*/
		{ 512UL*1024UL*1024UL/512UL, 0x44000UL/512UL },	/* 512MB ȏ 	*/
		{ 256UL*1024UL*1024UL/512UL, 0x24000UL/512UL },	/* 256MB ȏ 	*/
		{ 128UL*1024UL*1024UL/512UL, 0x18000UL/512UL },	/* 128MB ȏ 	*/
		{  64UL*1024UL*1024UL/512UL, 0x18000UL/512UL },	/*  64MB ȏ 	*/
		{  32UL*1024UL*1024UL/512UL, 0x0c000UL/512UL },	/*  32MB ȏ 	*/
		{  16UL*1024UL*1024UL/512UL, 0x0c000UL/512UL },	/*  16MB ȏ 	*/
		{   0UL*1024UL*1024UL/512UL, 0x0c000UL/512UL }	/*  16MB  	*/
	};
	tableSize = (unsigned short)(sizeof(clustTbl)/sizeof(struct t_total_sect_vs_data_point));

	for( i = 0; i < tableSize; ++i )
	{
		if( clustTbl[i].totalSize < pFormatInfo->tmp.driveSector )
		{
			pFormatInfo->tmp.dataPoint =
					clustTbl[i].dataPoint * pFormatInfo->bytesPerSector; 
			break;
		}
	}
}

/****************************************************************************/
/* T  v																	*/
/*        tH[}bg̎s												*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*       formatInfo ɂĒ߂ꂽ`̃tH[}bgȂB		*/
/*       fromat ȉ͌Œō쐬B									*/
/*         FAT EEEEEEEEEEEEEEE 2							*/
/*         [gfBNgGgEEEEEEEEEE 512				*/
/*         ʎqEEEEEEEEEEEEEEE 0xAA55						*/
/*       ܂Aȉ̐B										*/
/*         Ep[eBVɂ͑ΉȂB								*/
/*           Ƀp[eBV͂P݂̂ƂătH[}bg	*/
/*          ȂB														*/
/*           p[eBVɕĂꍇ̓p[eBV̐ݒ	*/
/*           ƍꂽp[eBVƂ̖\B		*/
/*         EMBR 쐬p[eBV͂P̂ݍ쐬B					*/
/*         E{[ID͍쐬łȂB									*/
/*           ({[ ID ROOT fBNg̐擪Ggɍ쐬B)*/
/*         Eu[ĝłANeBup[eBV͍쐬łȂB			*/
/****************************************************************************/
unsigned short execFormat( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned short err;									/* G[R[h			*/
	if( pFormatInfo->makeMbr != FALSE )
	{
		err = makeMbr( pFormatInfo );					/* MBR 쐬 */
		if( err != RF_OK )		goto ERR_EXIT;
	}
	if( ( pFormatInfo->makeBpb != FALSE ) ||
		( pFormatInfo->makeMbr != FALSE ) )
	{
		err = makeBpb( pFormatInfo );					/* BPB 쐬 */
		if( err != RF_OK )			goto ERR_EXIT;
	}
	err = makeFat( pFormatInfo );						/* FAT 쐬 */
	if( err != RF_OK )			goto ERR_EXIT;
	err = makeRoot( pFormatInfo );						/* ROOT fBNg 쐬 */
	if( pFormatInfo->clearClust != FALSE )
	{
		err = clearCluster( pFormatInfo );				/* NX^̈̃NA */
		if( err != RF_OK )		goto ERR_EXIT;
	}
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        MBR ̍쐬														*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        MBR 1 ubNNAO̕珇ԂɏށB				*/
/*        ރf[^͈ȉ̂ƂB										*/
/*          Eu[gCWP[^[											*/
/*          EVXeID(FAT12/16)											*/
/*          Ep[eBV̐擪ʒu										*/
/*          Ep[eBṼZN^										*/
/*            wb_AV_AgbN͂Ƃ肠ĂȂB		*/
/****************************************************************************/
unsigned short makeMbr( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned short err = RF_OK;
	unsigned long sectorNum = 0UL;						/* ZN^			*/
	char wkStr[4];								/* Ɨ̈	*/
	char systemId = (char)MBR_SYSTEM_ID_FAT12;		/* VXeID			*/

	sectorNum = pFormatInfo->tmp.partitionSector;		/* p[eBṼZN^	*/

	/* SYSTEM ID ߂ */
	err = RF_ERR_NOT_DEAL_BIG_SIZE;						/* TCY傫đΉłȂ	*/
	if( sectorNum < 32680UL )
	{
		systemId = (char)MBR_SYSTEM_ID_FAT12;
	}
	else if( sectorNum < 65535UL )
	{
		systemId = (char)MBR_SYSTEM_ID_FAT16;
	}
	else if( sectorNum < 4UL*1024UL*1024UL )
	{
		systemId = (char)MBR_SYSTEM_ID_FAT16_BIG;
	}
	else
	{
		/* G[ATCYΉs	*/
		goto ERR_EXIT;			/* TCYΉs	*/
	}

	err = RfbFill( 0UL, (char)0x00, (unsigned long)pFormatInfo->bytesPerSector);
	if( err != RF_OK )			goto ERR_EXIT;

	/* u[gCWP[^[ */
	err = RfbWrite( MBR_PARTITION_TABLE+MBR_PT_BOOT_INDICATOR,
							"\x00",
							1UL,
							TRUE );						/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* Jnwb_AZN^AV_ */
	err = RfbWrite( MBR_PARTITION_TABLE+MBR_PT_START_POINT,
							"\x01\x1a\x00",
							3UL,
							TRUE );						/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	err = RfbWrite( MBR_PARTITION_TABLE+MBR_PT_SYSTEM_ID,
							&systemId,
							1UL,
							TRUE );						/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* Iwb_AZN^AV_ */
	err = RfbWrite( MBR_PARTITION_TABLE+MBR_PT_END_POINT,
							"\x01\x60\xc6",
							3UL,
							TRUE );						/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* ZN^擪ʒuiBꂽZN^j */
	brokenULongData( pFormatInfo->bpbSector, wkStr );	/* i[`ɕϊ	*/
	err = RfbWrite( MBR_PARTITION_TABLE+MBR_PT_BPB_POINT,
							wkStr,
							4UL,
							TRUE );						/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* p[eBṼZN^ */
	brokenULongData( sectorNum, wkStr );				/* i[`ɕϊ	*/
	err = RfbWrite( MBR_PARTITION_TABLE+MBR_PT_SECTOR_IN_PERTITION,
							wkStr,
							4UL,
							TRUE );						/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* signature */
	brokenUShortData( RF_SIGNATURE_VALUE, wkStr );		/* i[`ɕϊ	*/
	err = RfbWrite( MBR_SIGNATURE,
							wkStr,
							2UL,
							TRUE );						/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;
	
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        BPB ̍쐬														*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        MBR 1 ubNNAO̕珇ԂɏށB				*/
/*        ރf[^͈ȉ̂ƂB										*/
/*          E1NX^̃ZN^											*/
/*          E\ZN^													*/
/*          EFAT(2Œ)													*/
/*          E[gfBNgGg(512Œ)							*/
/*          Ep[eBVZN^(small)									*/
/*          E1FAT ̃ZN^												*/
/*          E1gbÑZN^											*/
/*          Ep[eBVZN^(large)									*/
/*          E(0xaa55Œ)												*/
/****************************************************************************/
unsigned short makeBpb( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned short err = RF_OK;
	char wkStr[4];										/* Ɨ̈	*/
	unsigned long largeSector = 0UL;					/* p[eBṼZN^(large)	*/
	unsigned short smallSector = 0;						/* p[eBṼZN^(small)	*/
	char * pFileSystem;									/* t@CVXe		*/

	/* p[eBṼZN^large/small */
	if( pFormatInfo->tmp.partitionSector <= 0x0000ffffUL )
	{
		smallSector = (unsigned short)pFormatInfo->tmp.partitionSector;
		largeSector = 0UL;
	}
	else
	{
		smallSector = 0;
		largeSector = pFormatInfo->tmp.partitionSector;
	}

	err = RfbFill( pFormatInfo->tmp.bpbAddr,
					 (char)0x00,
					 (unsigned long)pFormatInfo->bytesPerSector);		/* BPB NA	*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* u[gR[h */
	err = RfbWrite( pFormatInfo->tmp.bpbAddr,
							"\xeb\x00\x90",
							3UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* formatVXe */
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_OEM_ID,
							"MSDOS5.0",
							8UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	
	/* 1 ZN^̃oCg */
	brokenUShortData( pFormatInfo->bytesPerSector, wkStr );	
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_BYTES_PER_SECTOR,
							wkStr,
							2UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;


	/* 1NX^̃ZN^ */
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_SECTOR_PER_CLUSTER,
							(char*)&pFormatInfo->sectPerClust,
							1UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* \ZN^ */
	brokenUShortData( pFormatInfo->resSector, wkStr );
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_RSVD_SEC_CNT,
							wkStr,
							2UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* FAT  */
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_NUM_OF_FAT,
							"\x02",	/* FAT  2 Œ	*/
							1UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* [gfBNgGg */
	brokenUShortData( 512, wkStr );					/* 512 Œ	*/
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_NUM_OF_ROOT,
							wkStr,
							2UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* p[eBVZN^(small) */
	brokenUShortData( smallSector, wkStr );
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_TOTAL_SECT,
							wkStr,
							2UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* fBAʎq */
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_MEDIA_DESCRIPTOR,
							"\xf8",
							1UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;


	/* 1FAT ̃ZN^ */
	brokenUShortData( pFormatInfo->tmp.fatSector, wkStr );
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_SECTOR_PER_FAT,
							wkStr,
							2UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* 1gbÑZN^ */
/*	BPB_SECTOR_PER_TRUCK
*/

	/* BPB ܂ł̃ZN^ */
	brokenULongData( (unsigned long)pFormatInfo->bpbSector, wkStr );
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_HIDDEN_SECT,
							wkStr,
							4UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* p[eBVZN^(large) */
	brokenULongData( largeSector, wkStr );
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_LARGE_TOTAL_SECT,
							wkStr,
							4UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* hCuԍ */
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_PHYSICAL_DRIVE_NUM,
							"\x80",
							1UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* ʎq */
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_EXT_BOOT_SIGNATURE,
							"\x29",
							1UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* {[x̖c */
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_VOLUME_LABEL,
							"NO NAME   ",
							11UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	
	/* t@CVXe */
	pFileSystem = "FAT16   ";
	if( pFormatInfo->tmp.fSystem == RF_F_SYSTEM_FAT12 )
	{
		pFileSystem = "FAT12   ";
	}
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_FILE_SYSTEM_TYPE,
							pFileSystem,
							8UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

	/*  */
	brokenUShortData( RF_SIGNATURE_VALUE, wkStr );
	err = RfbWrite( pFormatInfo->tmp.bpbAddr + (unsigned long)BPB_SIGNATURE,
							wkStr,
							2UL,
							TRUE );					/* 			*/
	if( err != RF_OK )			goto ERR_EXIT;

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        FAT ̍쐬														*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        FAT SubNNA擪ށB						*/
/****************************************************************************/
unsigned short makeFat( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned long addr = pFormatInfo->tmp.fat1Point;
	char wkStr[4];
	unsigned i;										/* [ṽCfbNX	*/
	unsigned short err;								/* G[R[h			*/

	/* ̌AڃfBAɏނ̂Ńobt@tbVĂ */
	err = RfbReflect();
	if( err != RF_OK )				goto ERR_EXIT;
	
	/* 2 FAT ԂAăNA */
	for( i = 0; i < (pFormatInfo->tmp.fatSector*2U); ++i )
	{
		err = drvFill( addr, (char)0x00 );
		if( err != RF_OK )			goto ERR_EXIT;
		addr += (unsigned long)pFormatInfo->bytesPerSector;
	}

	if( pFormatInfo->tmp.fSystem == RF_F_SYSTEM_FAT12 )
	{
		/* FAT12 ̏ꍇ */
		brokenUShortData( RF_F_CLUST_FAT12_FIRST, wkStr );
		brokenUShortData( (unsigned short)(RF_F_CLUST_FAT12_TERMINATE << 4),
												 &wkStr[2] );
		wkStr[1] |= wkStr[2];
		wkStr[2] = wkStr[3];
		wkStr[3] = (char)0;
	}
	else 
	{
		/* FAT16 ̏ꍇ */
		brokenUShortData( RF_F_CLUST_FAT16_FIRST, wkStr );
		brokenUShortData( RF_F_CLUST_FAT16_TERMINATE, &wkStr[2] );
	}
	

	/* FAT1 ̐擪 */
	err = RfbWrite( pFormatInfo->tmp.fat1Point,
							wkStr,
							4UL,
							TRUE );					/* 				*/
	if( err != RF_OK )			goto ERR_EXIT;

	/* FAT2 ̐擪 */
	err = RfbWrite( pFormatInfo->tmp.fat2Point,
							wkStr,
							4UL,
							TRUE );					/* 				*/
	if( err != RF_OK )			goto ERR_EXIT;

ERR_EXIT:
	return err;
	
}

/****************************************************************************/
/* T  v																	*/
/*        ROOT fBNg̍쐬											*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        ROOT fBNg̑SZN^B							*/
/****************************************************************************/
unsigned short makeRoot( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned short i;								/* [ṽCfbNX	*/
	unsigned long addr;								/* NAAhX		*/
	unsigned short err;								/* G[R[h			*/

	/* ̌AڃfBAɏނ̂Ńobt@tbVĂ */
	err = RfbReflect();
	if( err == RF_OK )
	{
		addr = pFormatInfo->tmp.rootPoint;
		for( i = 0; i < pFormatInfo->tmp.rootSector; ++i )
		{
			err = drvFill( addr, (char)0x00 );		/* ROOT NA			*/
			if( err != RF_OK )		break;
			addr += (unsigned long)pFormatInfo->bytesPerSector;
		}
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        f[^̈NA											*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        f[^̈悷ׂĂNA										*/
/****************************************************************************/
unsigned short clearCluster( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned long addr;								/* NAAhX		*/
	unsigned short i,j;								/* [ṽCfbNX	*/
	unsigned short err = RF_OK;						/* G[R[h			*/

	/* ̌AڃfBAɏނ̂Ńobt@tbVĂ */
	err = RfbReflect();
	if( err != RF_OK )				goto ERR_EXIT;

	addr = pFormatInfo->tmp.dataPoint;
	for( i = 0; i < pFormatInfo->tmp.clustNum; ++i )
	{
		for( j = 0; j < (unsigned short)pFormatInfo->sectPerClust; ++j )
		{
			err = drvFill( addr, (char)0x00 );			/* NX^NA		*/
			if( err != RF_OK )		goto ERR_EXIT;
			addr += (unsigned long)pFormatInfo->bytesPerSector;
		}
	}

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        formatInfo vZċ߂l𖄂߂								*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        ȉ̒lvZB												*/
/*        Ep[eBṼZN^										*/
/*        EAhX BPB ʒu												*/
/*        ENX^(???)													*/
/*        EFAT AhX													*/
/*        EFAT ̃ZN^													*/
/*        Et@CVXe敪											*/
/*        FATZN^̌vZ@												*/
/*          p:p[eBṼZN^										*/
/*          R:rootfBNg̃ZN^									*/
/*          r:BPBFAT܂ł̃ZN^(resSector)							*/
/*          F:1FAT ̃NX^												*/
/*          k:ǗPʂ̃oCg(FAT16=2AFAT12=1.5)						*/
/*          c:NX^̃ZN^											*/
/*          s:ZN^̃oCg												*/
/*																			*/
/*         ̂悤ɕϐ߂												*/
/*          f[^̈̃ZN^ = (p-2F-r-R) @					*/
/*          f[^̈̃NX^ = @/c A					*/
/*          1FAT̃oCg = A/k B						*/
/*          1FAT̃ZN^ = B/s (؂グ)						*/
/*																			*/
/*         L܂Ƃ߂													*/
/*          F = (p-2F-r-R)k/(cEs)											*/
/*																			*/
/*         F ߂鎮ɕϊ												*/
/*          F = (p-r-R)k/(cs+2k)											*/
/****************************************************************************/
unsigned short updateCalcInfo( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned long fatAndDataClust;						/* FAT  f[^̃ZN^ */
	unsigned long denomi = 0UL;							/* FAT vZ̕	*/
	unsigned long ulwk;									/* vZr̈ꎞ̈*/
	unsigned short err = RF_OK;							/* G[R[h			*/

	/* BPB AhX */
	pFormatInfo->tmp.bpbAddr =
		(unsigned long)pFormatInfo->bpbSector *
		(unsigned long)pFormatInfo->bytesPerSector;		/* BPB ʒuAhXɕϊ */

	/* FAT TCY FAT12ƂČvZ */
	fatAndDataClust =
			pFormatInfo->tmp.partitionSector -
			(unsigned long)pFormatInfo->resSector - 		/* resSector  BPB Ԃ܂܂Ă */
			(unsigned long)DIR_ROOT_BYTE_NUM / 
			(unsigned long)pFormatInfo->bytesPerSector;		/* root fBNgԂ	*/
	ulwk = fatAndDataClust + (fatAndDataClust+1) / 2UL;		/* k  1.5 Ƃā~ks(؂グ) */
	denomi = (unsigned long)pFormatInfo->sectPerClust *
			 (unsigned long)pFormatInfo->bytesPerSector + 3UL;	/* (c*s+2k) */
	ulwk = (ulwk + (denomi-1))/ denomi;						/* ؂グ邽ߕ -1 𕪎qɑĂ */
	pFormatInfo->tmp.fatSector = (unsigned short)ulwk;		/* 1FAT ̃ZN^ۑ */
	pFormatInfo->tmp.fSystem = (char)RF_F_SYSTEM_FAT12;		/* t@CVXe = ŏ FAT12 ƂĂ	*/

	/* FAT12 ͈̔͂ɓ邩H */
	if( clustNum( pFormatInfo )  > RF_CLUSTER_NUM_FAT12 )
	{
		/* FAT12 ͈̔͂ɓȂ̂	*/
		/* FAT16 ƂČvZ				*/
		ulwk = fatAndDataClust * 2UL;						/* k = 2  */
		denomi = (unsigned long)pFormatInfo->sectPerClust *
				 (unsigned long)pFormatInfo->bytesPerSector + 4UL;
		ulwk = (ulwk + (denomi-1))/ denomi;					/* ؂グ邽ߕ -1 𕪎qɑĂ */
		pFormatInfo->tmp.fatSector = (unsigned short)ulwk;	/* 1FAT ̃ZN^ۑ */
		pFormatInfo->tmp.fSystem = (char)RF_F_SYSTEM_FAT16;	/* t@CVXe = FAT16 Ƃ	*/
		if( clustNum( pFormatInfo ) > RF_CLUSTER_NUM_FAT16 )
		{
			/* FAT16 ŃtH[}bgłȂ */
			pFormatInfo->tmp.fSystem = (char)RF_F_SYSTEM_UNKNOWN;	/* t@CVXe = s			*/
			err = RF_ERR_CLUSTER_OVER;
			goto ERR_EXIT;
		}
	}
	if( ( pFormatInfo->option & RF_FORMAT_MODE_DOS ) != 0 )
	{
		/* DOS [h̎s */
		/* (1NX^-1) ZN^ɋ󂯂悤 resSector 𒲐 */
		/* NX^邪ɂt@CVXe`͕ύXȂ */
		ulwk = tailRemain( pFormatInfo );					/* ZN^̗] */
		if( ulwk <  ((unsigned long)pFormatInfo->sectPerClust - 1UL) )
		{
			pFormatInfo->resSector += (unsigned short)ulwk + 1;
		}
	}

	pFormatInfo->tmp.fat1Point = 
		pFormatInfo->tmp.bpbAddr + 
		(unsigned long)pFormatInfo->resSector *
		(unsigned long)pFormatInfo->bytesPerSector;			/* FAT AhX߂ */

	pFormatInfo->tmp.clustNum =
				(unsigned short)clustNum( pFormatInfo );	/* p[eBṼNX^*/

	pFormatInfo->tmp.fat2Point = 
		pFormatInfo->tmp.fat1Point +
		pFormatInfo->tmp.fatSector *
		(unsigned long)pFormatInfo->bytesPerSector;			/* FAT2 ̃AhX	*/

	pFormatInfo->tmp.rootPoint = 
		pFormatInfo->tmp.fat2Point +
		pFormatInfo->tmp.fatSector * 
		(unsigned long)pFormatInfo->bytesPerSector;			/* rootfBNg ̃AhX	*/

	pFormatInfo->tmp.rootSector =
						(unsigned short)
						( DIR_ROOT_BYTE_NUM /
						  pFormatInfo->bytesPerSector);		/* rootfBNg̃ZN^	*/

	pFormatInfo->tmp.dataPoint = 
		pFormatInfo->tmp.rootPoint +
		(unsigned long)DIR_ROOT_BYTE_NUM;					/* f[^̈̃AhX	*/
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        NX^߂												*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        NX^														*/
/*   																	*/
/*        f[^̈̃ZN^߁APNX^̃ZN^ŊB	*/
/****************************************************************************/
unsigned long clustNum( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned long dataSect;								/* f[^̈̃ZN^	*/
	dataSect =
			pFormatInfo->tmp.partitionSector -
			(unsigned long)pFormatInfo->resSector - 	/* FAT܂ł̃ZN^		*/
			(unsigned long)pFormatInfo->tmp.fatSector * 2UL - /* FAT Ԃ	*/
			(unsigned long)DIR_ROOT_BYTE_NUM / 
			(unsigned long)pFormatInfo->bytesPerSector;	/* root fBNgԂ	*/
	return dataSect / (unsigned long)pFormatInfo->sectPerClust;		/* NX^			*/
}

/****************************************************************************/
/* T  v																	*/
/*        NX^mۂƂɍŌɂł󂫗̈̃ZN^߂	*/
/* p[^																*/
/*        T_RF_FORMAT_INFOFtH[}bg̃IvV						*/
/* ߂l																	*/
/*        NX^														*/
/*   																	*/
/*        f[^̈̃NX^߂鎞̗]vZB				*/
/****************************************************************************/
unsigned long tailRemain( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned long dataSect;								/* f[^̈̃ZN^	*/
	dataSect =
			pFormatInfo->tmp.partitionSector -
			(unsigned long)pFormatInfo->resSector - 	/* FAT܂ł̃ZN^	*/
			(unsigned long)pFormatInfo->tmp.fatSector * 2UL - /* FAT Ԃ	*/
			(unsigned long)DIR_ROOT_BYTE_NUM / 
			(unsigned long)pFormatInfo->bytesPerSector;	/* root fBNgԂ*/
	return dataSect % (unsigned long)pFormatInfo->sectPerClust;		/* ZN^̗]			*/
}

/****************************************************************************/
/* T  v																	*/
/*        f[^̈̊JnAhX BPB ʒutZ					*/
/* p[^																*/
/*        pFormatInfoFtH[}bg̃IvV								*/
/* ߂l																	*/
/*        TRUEF														*/
/*        FALSEFs														*/
/*   																	*/
/*        SD J[h[hŃtH[}bgۂ BPB ʒu߂B			*/
/*        vZɎgpȉ̕ϐ͒li[ĂƁB					*/
/*         pFormatInfo->tmp.driveSectorEEEEEEEhCuŜ̃ZN^	*/
/*         pFormatInfo->tmp.dataPointEEEEEEEEf[^̊JnAhX	*/
/*         pFormatInfo->bytesPerSector EEEEEEE1ZN^̃oCg		*/
/*         pFormatInfo->sectPerClust EEEEEEEE1NX^̃ZN^	*/
/*        vZʂ pFormatInfo->bpbSector Ɋi[B					*/
/*        w dataPoint ł BPB ʒu߂ȂƂ͖߂l FALSE	*/
/*        ƂȂB															*/
/****************************************************************************/
unsigned short calcBpbSectByDataPoint( T_RF_FORMAT_INFO * pFormatInfo )
{
	unsigned long dataPointBySect;					/* f[^̈̃ZN^ʒu*/
	unsigned long dataSectNum;						/* f[^̈̃ZN^	*/
	unsigned long clusterNum;						/* f[^̈̃NX^*/
	unsigned long fatSize;							/* 1FAT̃TCY			*/
	unsigned long rootSize;							/* rootfBNg̃TCY*/
	unsigned long sectPerClust;						/* NX^̃ZN^	*/
	unsigned long bytesPerSector;					/* 1ZN^̃oCg	*/
	unsigned short res = FALSE;						/* vZ				*/

	sectPerClust = (unsigned long)pFormatInfo->sectPerClust;
	bytesPerSector = (unsigned long)pFormatInfo->bytesPerSector;

	dataPointBySect = pFormatInfo->tmp.dataPoint /
									 bytesPerSector;	/* f[^̈̃ZN^ʒu*/
	dataSectNum = pFormatInfo->tmp.driveSector
								 - dataPointBySect;		/* f[^̈̃ZN^	*/
	clusterNum = dataSectNum / sectPerClust;			/* f[^̈̃NX^ */

	/* FAT TCY߂ */
	if( clusterNum <= RF_CLUSTER_NUM_FAT12 )
	{
		fatSize = clusterNum + (clusterNum+1) / 2UL;	/* ~1.5			*/
	}
	else if( clusterNum <= RF_CLUSTER_NUM_FAT16 )
	{
		fatSize = clusterNum * 2UL;
	}
	else
	{
		goto ERR_EXIT;
	}

	fatSize = (fatSize + (bytesPerSector-1UL)) /
									 bytesPerSector;	/* FAT TCYZN^ɕϊ */
	rootSize = (unsigned long)DIR_ROOT_BYTE_NUM /
									 bytesPerSector;	/* root fBNgZN^*/
	/*  0x20 Ă͓̂K */
	if( (fatSize * 2 + rootSize + 0x20) < dataPointBySect )
	{
		pFormatInfo->bpbSector = 
					(unsigned short)(		
						dataPointBySect -
						 (fatSize * 2UL + rootSize +1 ));/* BPB ZN^ʒu߂	*/
		res = TRUE;
	}

ERR_EXIT:
	return res;
}

