/****************************************************************************/
/* T  vF eXgP[XIėp@\										*/
/*   F eXgŎgpėp@\܂Ƃ߂								*/
/* 쐬F 2011.09.23														*/
/* XVF 2014.02.15														*/
/* Copyright    resove														*/
/****************************************************************************/
#include "RfInterface.h"
#include "RfFormat.h"
#include "RfErrCode.h"

#include "TstWriteVal.h"
#include "TstGeneral.h"
#include "TstDefine.h"
#include "TraceOut.h"

char * GetOrgErrCodeChar( unsigned short errCode );

/****************************************************************************/
/* T  v																	*/
/*        j[\@\													*/
/* p[^																*/
/*        testCase   FeXgP[X̍\									*/
/*        testCaseNumFeXgP[X̐										*/
/*        title      Fj[ɕ\^Cg							*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        󂯎j[\ĎseXgP[XI		*/
/****************************************************************************/
void TestMenu(const T_TEST_MENU * testCase, unsigned short testCaseNum, char * title)
{
	int i = 0;
	char selectChar = 0;

	while( selectChar != 'q' )
	{
		/*j[\ */
		operationOut( "\n************************************************************\n" );
		operationOut( title );
		operationOut( "\n************************************************************\n" );
		for( i = 0; i < testCaseNum; i++ )
		{
			operationOut("%c. %s\n", testCase[i].select, testCase[i].title);
		}
		operationOut("==> ");
		selectChar = operationIn();
		operationOut("%c", selectChar );
		operationOut("\n");

		if( selectChar != 'q' )
		{
			/* IꂽeXgP[Xs */
			for( i = 0; i < testCaseNum; i++ )
			{
				if( (selectChar == testCase[i].select) || (selectChar == 'x'))
				{
					if( testCase[i].func != 0)				/* eXg֐L */
					{
						(*testCase[i].func)();				/* eXg֐s */
					}
				}
			}
			operationOut("\x07");							/* 炷 */
		}
	}
}

/****************************************************************************/
/* T  v																	*/
/*        16 iϊ													*/
/* p[^																*/
/*        pBuffFi[̈										*/
/*        val  Fϊ̐l												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        l S 16iƂĕɕϊB						*/
/****************************************************************************/
void hexToChar(char * pBuff, unsigned short val )
{
	unsigned short i;
	unsigned short dig = 0x1000;
	char unit;

	for( i = 0; i < 4; ++i )
	{
		unit = (char)((val / dig) % 0x10);
		if( unit < 0x0a)	pBuff[i] = (char)(unit | 0x30);
		else				pBuff[i] = (char)(unit + ('a'- 0x0a));
		dig /= 0x10;
	}
	pBuff[i] = '\0';

}

/****************************************************************************/
/* T  v																	*/
/*        10 iϊ													*/
/* p[^																*/
/*        pBuff Fi[̈										*/
/*        val   Fϊ̐l												*/
/*        minDigFŏ̌												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        l10iƂĕɕϊB								*/
/*        minDig Ɏw肳ꂽlɂȂ 0 łɂB			*/
/****************************************************************************/
unsigned short numToChar(char * pBuff, unsigned long val, unsigned long minDig )
{
	unsigned short i;
	unsigned long dig = 1000000000UL;
	char unit;
	unsigned short datPoint = 0;
	char supplyFlag = 0;

	for( i = 0; dig != 0; ++i )
	{
		unit = (char)((val / dig) % 10);
		pBuff[datPoint] = (char)(unit | 0x30);
		dig /= 10;
		if( (unit != 0) && (supplyFlag == 0) )	supplyFlag = 1;
		if( supplyFlag )	++datPoint;
		if( minDig > dig ) supplyFlag = 1;
	}
	pBuff[datPoint] = '\0';

	return datPoint;
}


static const T_ERR_CODE_STR errCodeStr[] = {
	ERR_CODE_STR(RF_OK),								/* G[Ȃ */

	/* obt@ANZX֘A */
	ERR_CODE_STR(RF_ERR_BUFF_DEFINE),					/* obt@`̌ */
	ERR_CODE_STR(RF_ERR_BUFF_ADDRESS),					/* AhXw̌	*/
	ERR_CODE_STR(RF_ERR_BUFF_LEN),						/* w̌	*/
	ERR_CODE_STR(RF_ERR_BUFF_FLUSH),					/* Xgsi\tgBUGj	*/
	ERR_CODE_STR(RF_ERR_BUFF_UPDATE),					/* obt@XV̕s	*/
	ERR_CODE_STR(RF_ERR_BUFF_TAKE),						/* obt@̃f[^擾s	*/
	ERR_CODE_STR(RF_ERR_CANT_WRITE_FOR_BUFF),			/* obt@TCYŝߏ݂łȂ	*/
	ERR_CODE_STR(RF_ERR_BUFF_INITIAL),					/* ĂȂ	*/
	ERR_CODE_STR(RF_ERR_DEFINE_DRIVER),					/* hCo֐w肳ĂȂ	*/

	/* MBR,BPB֘A */
	ERR_CODE_STR(RF_ERR_MBR_SIGNATURE),					/* MBR SIGNATURE  */
	ERR_CODE_STR(RF_ERR_BPB_SIGNATURE),					/* BPB SIGNATURE  */
	ERR_CODE_STR(RF_ERR_UNKNOWN_FILE_SYSTEM),			/* FAT12,FAT16 ȊÕt@CVXe */
	ERR_CODE_STR(RF_ERR_RSVD_SECT_CNT),					/* \ZN^ */
	ERR_CODE_STR(RF_ERR_NOT_DEAL_BIG_SIZE),				/* TCY傫đΉłȂ */
	ERR_CODE_STR(RF_ERR_CLUSTER_OVER),					/* NX^ătH[}bgłȂ */
	ERR_CODE_STR(RF_ERR_SECTOR_SIZE),					/* ΉłȂZN^TCY */


	/* t@CANZX֘A */
	ERR_CODE_STR(RF_ERR_NOT_OPENED),					/* I[vĂȂ */
	ERR_CODE_STR(RF_ERR_ALREADY_OPEND),					/* łɃI[vĂt@CI[v悤Ƃ */
	ERR_CODE_STR(RF_ERR_OUT_OF_LENGTH),					/* t@C̃TCY𒴂 */
	ERR_CODE_STR(RF_ERR_NOT_FOUND),						/* t@CȂ */
	ERR_CODE_STR(RF_ERR_INVALID_NAME),					/* t@Cs */
	ERR_CODE_STR(RF_ERR_BROKEN_FILE),					/* t@CĂ */
	ERR_CODE_STR(RF_ERR_READ_ONLY),						/* ݋֎~̃t@C݃[hŃI[v */
	ERR_CODE_STR(RF_ERR_EOF),							/* ǂݍݒ EOF ɒB */
	ERR_CODE_STR(RF_ERR_NO_SPACE),						/* 󂫗̈悪̂ŏ݂ȂȂ */
	ERR_CODE_STR(RF_ERR_FAT_NUM),						/* FAT ԍ̌i\tgBUGj */
	ERR_CODE_STR(RF_ERR_CANNOT_APPEND),					/* ǉݗv͎󂯕tȂ */
	ERR_CODE_STR(RF_ERR_NO_ROOT_SPACE),					/* [gfBNgɋ󂫃Xy[X	*/
	ERR_CODE_STR(RF_ERR_ALREADY_EXIST),					/* t@C݂͑	*/
	ERR_CODE_STR(RF_ERR_NOT_FREE_FCB),					/* FCB ̋󂫂Ȃ	*/
	ERR_CODE_STR(RF_ERR_OPEN_MODE),						/* I[v[ȟ	*/
	ERR_CODE_STR(RF_ERR_NOT_INITIALIZE),				/* ĂȂ	*/
	ERR_CODE_STR(RF_ERR_DEL_DIR_NEST),					/* RfDelDir ŃlXgI[o[	*/
	ERR_CODE_STR(RF_ERR_NOT_DIRECTORY),					/* fBNgł͂Ȃ	*/
	ERR_CODE_STR(RF_ERR_ROOT_DIRECTORY),				/* root fBNgw肳ꂽ	*/
	ERR_CODE_STR(RF_ERR_SEEK_OPTION),					/* seek IvVw̌	*/
	ERR_CODE_STR(RF_ERR_FMT_OPTION),					/* format IvVw̌	*/
	ERR_CODE_STR(RF_ERR_FMT_THERE_IS_OPENED),			/* format I[ṽt@ĈŃtH[}bg͂ȂȂ */
	ERR_CODE_STR(RF_ERR_FMT_INIT_FAIL),					/* format sĂ */
	ERR_CODE_STR(RF_ERR_DIRECTORY),						/* fBNgw肳ꂽ		*/
	ERR_CODE_STR(RF_ERR_MOVE_POSTERITY),				/* z̃fBNgւ̈ړw	*/
	ERR_CODE_STR(RF_ERR_GET_TIME),						/* 擾̎s	*/
	ERR_CODE_STR(RF_ERR_NOT_OPEN_DIR),					/* RfOpenDir()ŃI[vĂȂ	*/
	ERR_CODE_STR(RF_ERR_NOT_USEABLE_LONG_NAME),			/* Long Name gps	*/

};

/****************************************************************************/
/* T  v																	*/
/*        G[R[h當T										*/
/* p[^																*/
/*        errCodeFG[R[h												*/
/* ߂l																	*/
/*        Ή镶ւ̃|C^										*/
/*   																	*/
/*         																	*/
/****************************************************************************/
char * GetErrCodeChar( unsigned short errCode )
{
	static const unsigned short recNum = sizeof(errCodeStr)/sizeof(T_ERR_CODE_STR);
	char * errStr = NULL;
	unsigned short i;

	/* t@CVXẽG[R[hT */
	for( i = 0; i < recNum; i++ )
	{
		if( errCodeStr[i].code == errCode )
		{
			errStr = errCodeStr[i].str;
			break;
		}
	}

	/* ŗL̃G[R[hT */
	if( errStr == NULL )
	{
		errStr = GetOrgErrCodeChar( errCode );
		if( errStr == NULL )
		{
			errStr = "Un Known Code.";
		}
	}

	return errStr;
}

/****************************************************************************/
/* T  v																	*/
/*        eXg														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TestReady( void )
{
	unsigned short err;

	err = RfInitFileSystem( );
	CHK_ERR_CODE(err, RF_OK, "RfInitFileSystem()");
	err = RfFormat( RF_FORMAT_MODE_SD );		/* tH[}bgs	*/
	CHK_ERR_CODE(err, RF_OK, "RfFormat()");

}

/****************************************************************************/
/* T  v																	*/
/*        eXgI														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TestConclude( void )
{
	RfConclude( );
}

/****************************************************************************/
/* T  v																	*/
/*        foCXAtH[}bgȂǂ\						*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void dispCardInfo( void )
{
	T_RF_DRIVE_INFO driveInfo;
	unsigned short err;

	err = RfGetDriveInfo( &driveInfo );
	CHK_ERR_CODE(err, RF_OK, "RfGetDriveInfo");
	if( err == RF_OK )
	{
		TRACE_OUT((" ==== card info ====\n"));
		TRACE_OUT((" capacity(%lu)\n", driveInfo.cardSize));
		TRACE_OUT((" bpbPoint(0x%08lx)\n", driveInfo.bpbSector*(long)driveInfo.bytesPerSector));
		TRACE_OUT((" bpbPoint(0x%08lx)sect\n", driveInfo.bpbSector));
		TRACE_OUT((" fat size(%ld)\n", driveInfo.fatSize));
		TRACE_OUT((" rootPoint(0x%08lx)\n", driveInfo.rootPoint));
		TRACE_OUT((" bodyPoint(0x%08lx)\n", driveInfo.bodyPoint));
		TRACE_OUT((" clusterNum(%u)\n", driveInfo.clusterNum));
		TRACE_OUT((" cluster size(%lu)\n", driveInfo.bytesPerCluster));
		TRACE_OUT((" sector/cluster(%u)\n", driveInfo.sectorPerCluster ));
		if( driveInfo.fSystem == RF_F_SYSTEM_FAT12 )
		{
			TRACE_OUT((" FAT12 \n"));
		}
		else if(driveInfo.fSystem == RF_F_SYSTEM_FAT16 )
		{
			TRACE_OUT((" FAT16 \n"));
		}
		else
		{
			TRACE_OUT((" unknown file system.\n"));
		}
	}
}

/****************************************************************************/
/* T  v																	*/
/*        o[W\											*/
/* p[^																*/
/*        titleFo[WƂƂɕ\^Cg						*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void	TstVersion( char * title )
{
	T_RF_FSYS_VER fsysVer;

	TEST_TITLE( ( "%s", title ));

	RfGetVerSion( &fsysVer );
	TRACE_OUT(("FileSystem version = %04x\n", fsysVer.fsys));
	TRACE_OUT(("Driver version     = %04x\n", fsysVer.drv.ver));
	TRACE_OUT(("Driver type        = %s\n", fsysVer.drv.type));
	TRACE_OUT(("\n"));
}


