#include "DebugFunc.h"
#include "TraceOut.h"
#include "TstDefine.h"
#include "TstGeneral.h"

const static char versionTitle[] = "AkiH8SCI:System version. Build(" __DATE__ " " __TIME__ ")";

static void commonTest( void );
void TestOrgSelect( void );

void main()
{
	static const T_TEST_MENU testCase[] =
	{
		{'1', "file system common test.", 					commonTest},
		{'2', "Inspection depending on environment.",		TestOrgSelect},
		{'q', "quit",										0},

	};

	static const int testCaseNum = sizeof(testCase)/sizeof(T_TEST_MENU);

	InitLED();

    TstVersion((versionTitle));					/* o[W\ */
	TestMenu(testCase, testCaseNum, "AkiH8SCI:Use only SCI driver. Not use interrupt." );

	operationOut("finish!!\n");
	winkLoop();
}

void commonTest( void )
{
	TestSelect( "AkiH8(SCI):Common test." );
}

