/****************************************************************************/
/* T  vF t@CVXe												*/
/*   F I[vA[hACgȂǃ[U[C^tF[X				*/
/* 쐬F 2004.12.12														*/
/* XVF 2013.12.30														*/
/* Copyright F	resove														*/
/****************************************************************************/
#include "RfDriverInterface.h"
#include "RfDiskLayout.h"
#include "RfInterface.h"
#include "RfMiddle.h"
#include "RfControlBuff.h"

/****************************************************************************/
/* Ŏgp萔														*/
/****************************************************************************/
#define RF_FILESYSTEM_VERSION ( 0x0102 )		/* t@CVXeo[W */

/****************************************************************************/
/* ϐ																	*/
/****************************************************************************/
/****************************************************************************/
/* ֐																	*/
/****************************************************************************/
/* ݂t@CI[v */
static unsigned short openExist( char * fileName, T_RF_FCB * pFcb );
/* VKt@CI[v */
static unsigned short openForNew( char * fileName, T_RF_FCB * pFcb );

/****************************************************************************/
/* T  v																	*/
/*        t@CVXe										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*   																	*/
/*        MBR, BPB ǂݎX̏擾B擾͈ȉ̒ʂB	*/
/*              E[gfBNg̈ʒu									*/
/*              E[gfBNg̃TCY								*/
/*              EFAT ̈ʒu												*/
/*              EFAT ̃TCY												*/
/*              Et@CVXě`iFAT12/FAT16j						*/
/*              Ef[^̈̈ʒu											*/
/*              ENX^TCY											*/
/*              EubNiZN^jTCY									*/
/****************************************************************************/
unsigned short RfInitFileSystem( void )
{

	return RfmInit( );
}

/****************************************************************************/
/* T  v																	*/
/*        t@CVXe										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        t@C݂̏Ȃꍇ FAT1 gpď݂	*/
/*       ȂĂBt@CVXeƂĂ FAT1 ̓e FAT2 ɏ	*/
/*       ނƂŐłƂƂۏ؂B̂߂̊֐ŕ	*/
/*       X̂ FAT1 ̓e FAT2 ɏށB					*/
/*        J[hɑ΂ď݂Ȃꍇ̓J[hoOɓ	*/
/*       ֐sȂ΂ȂȂB										*/
/*        read ȂȂVXeł͎sȂĂx͂ȂB	*/
/****************************************************************************/
unsigned short RfConclude( void )
{
	unsigned short err;

	err = RfmConclude(  );							/* FAT1  FAT2 ɏ */
	if( err != RF_OK ) goto ERR_EXIT;

	if( rfDriverInterface.conclude != NULL )
	{
		err = drvConclude();						/* hCoI */
	}

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        hCu擾											*/
/* p[^																*/
/*        pDriveInfoFhCui[̈ւ̃|C^				*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_NOT_INITIALIZE ĂȂ							*/
/*   																	*/
/*        RfInitFileSystem()ȂɎs邱ƁB					*/
/****************************************************************************/
unsigned short RfGetDriveInfo( T_RF_DRIVE_INFO * pDriveInfo )
{
	unsigned short err = RfmIsInitConfirm();				/* 𒲂ׂ */

	if( err == RF_OK )
	{
		err = RfmGetDriveInfo( pDriveInfo );
	}
	return err;
}


/****************************************************************************/
/* T  v																	*/
/*        t@CI[v											*/
/* p[^																*/
/*        fileNameFt@C												*/
/*        mode    FI[v[h											*/
/*        pErr    FG[R[hi[̈ւ̃|C^					*/
/* ߂l																	*/
/*        T_RF_FCB \̂ւ̃|C^										*/
/*        NULL ̎̓G[													*/
/*   																	*/
/****************************************************************************/
T_RF_FCB * RfOpen( char * fileName, unsigned short mode, unsigned short * pErr )
{
	T_RF_FCB * pFcb = NULL;

	*pErr = RfmIsInitConfirm();							/* 𒲂ׂ */

	if( *pErr == RF_OK )
	{
		pFcb = RfmFindFreeFcb( );						/* FCB ̖gp̈T */

		if( pFcb )
		{
			*pErr = RfmInitUseFcb( pFcb );				/* FCB  */
			if( *pErr == RF_OK )
			{
				pFcb->openMode = (unsigned char)mode;
				if( (mode & RF_OPEN_WRITE_NEW) != 0 )
				{
					/* VK쐬 Open ̏ꍇ */
					if( RfbIsCanWrite() == TRUE )
					{
						if( rfDriverInterface.writePoll == NULL )
						{
							/* polling @\ꍇ	*/
							/* SEQ IvV͖		*/
							pFcb->openMode &= ~RF_OPEN_OPT_SEQ;
						}
						*pErr = openForNew( fileName, pFcb );
					}
					else
					{
						*pErr = RF_ERR_CANT_WRITE_FOR_BUFF;		/* obt@TCYŝߏ݂łȂ */
					}
				}
				else if( (mode & RF_OPEN_WRITE_OLD) != 0 )
				{
					/* ݂t@Cւ write */
					if( RfbIsCanWrite() == TRUE )
					{
						if( rfDriverInterface.writePoll == NULL )
						{
							/* polling @\ꍇ	*/
							/* SEQ IvV͖		*/
							pFcb->openMode &= ~RF_OPEN_OPT_SEQ;
						}
						*pErr = openExist( fileName, pFcb );		/* ݂t@CI[v */
						if( (pFcb->brk.sr.attribute & DIR_ATTR_READ_ONLY) !=  0 )
						{
							*pErr = RF_ERR_READ_ONLY;			/* ǂݎpt@C	*/
						}
					}
					else
					{
						*pErr = RF_ERR_CANT_WRITE_FOR_BUFF;		/* obt@TCYŝߏ݂łȂ */
					}
				}
				else if( (mode & RF_OPEN_WRITE_CREATE) != 0 )
				{
					/* create Open ̏ꍇ */
					if( RfbIsCanWrite() == TRUE )
					{
						if( rfDriverInterface.writePoll == NULL )
						{
							/* polling @\ꍇ	*/
							/* SEQ IvV͖		*/
							pFcb->openMode &= ~RF_OPEN_OPT_SEQ;
						}
						*pErr = openExist( fileName, pFcb );
						if( *pErr == RF_OK )
						{
							if( pFcb->brk.sr.firstCluster != 0 )
							{
								/* t@ĈFAT chain 폜 */
								*pErr = RfmDelFatChain( pFcb->brk.sr.firstCluster );
							}
							/* TCYA݈ʒuNA */
							pFcb->brk.sr.curCluster = 0;
							pFcb->brk.sr.firstCluster = 0;
							pFcb->brk.sr.pointInCluster = 0L;
							pFcb->brk.sr.totalLen = 0L;
							pFcb->brk.sr.curPoint = 0L;
						}
						else if( *pErr == RF_ERR_NOT_FOUND )
						{
							/* t@Cꍇ͐VɃI[v */
							*pErr = openForNew( fileName, pFcb );
						}
					}
					else
					{
						*pErr = RF_ERR_CANT_WRITE_FOR_BUFF;		/* obt@TCYŝߏ݂łȂ */
					}
				}
				else if( (mode & RF_OPEN_READ) != 0 )
				{
					/* read ݂̂̏ꍇ */
					if( rfDriverInterface.readPoll  == NULL )
					{
						/* polling @\ꍇ	*/
						/* SEQ IvV͖		*/
						pFcb->openMode &= ~RF_OPEN_OPT_SEQ;
					}
					*pErr = openExist( fileName, pFcb );/* ݂t@CI[v */
					pFcb->canWriteFlag = FALSE;					/* read [hȂ̂ŏ݋֎~ɂ	*/
				}
				else
				{
					*pErr = RF_ERR_OPEN_MODE;					/* I[v[ȟ */
				}
			}
		}
		else
		{
			*pErr = RF_ERR_NOT_FREE_FCB;
		}
	}

	if( ( *pErr != RF_OK ) && ( pFcb != NULL) )
	{
		/* G[ */
		pFcb->useFlag = FALSE;							/* gȂ̂ 0 ɖ߂ */
		pFcb = NULL;
	}
	return pFcb;
}

/****************************************************************************/
/* T  v																	*/
/*        ݂t@CI[v									*/
/* p[^																*/
/*        fileNameFt@C												*/
/*        pFcb    FFCB														*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_...̎̓G[											*/
/*   																	*/
/*        ݂t@C FCB B								*/
/****************************************************************************/
unsigned short openExist( char * fileName, T_RF_FCB * pFcb )
{
	unsigned short err;
	unsigned long entryAddr;
	unsigned short clust = 0;

	clust = RfmGetParentDir( fileName, &err );		/* ŉw̃fBNgNX^ԍ擾 */
	if( err != RF_OK ) {					goto ERR_EXIT;}

	entryAddr = RfmFindFileEntry( clust, fileName, &err );	/* ̃Gg邩T */
	if( err != RF_OK ) {					goto ERR_EXIT;}

	err = RfmCheckAlreadyOpen( entryAddr, pFcb );	/* łɃI[vĂ邩ׂ */
	if( err != RF_OK ) {					goto ERR_EXIT;}

	err = RfmTakeExistInfo( pFcb, entryAddr );	/* ݂t@Cŏ */
	if( err != RF_OK ) {					goto ERR_EXIT;}

	if( (pFcb->brk.sr.attribute & DIR_ATTR_DIRECTORY ) != 0 )
	{
		err = RF_ERR_DIRECTORY;					/* fBNg̓I[vłȂ */
		goto ERR_EXIT;
	}

	if( ( pFcb->openMode & RF_OPEN_OPT_SEQ ) != 0 )
	{
		err = RfmReadKick( pFcb );		/* ǂł */
	}

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        VK write ̂߂ɃI[v									*/
/* p[^																*/
/*        fileNameFt@C												*/
/*        pFcb    FFCB														*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_ALREADY_EXIST F݂t@CI[v悤Ƃ	*/
/*        RF_ERR_...̑ANZXG[									*/
/*   																	*/
/****************************************************************************/
unsigned short openForNew( char * fileName, T_RF_FCB * pFcb )
{
	unsigned short clust;
	unsigned short err = RF_OK;

	clust = RfmGetParentDir( fileName, &err );		/* ŉw̃fBNgNX^ԍ擾 */
	if( err == RF_OK )
	{
		RfmFindFileEntry( clust, fileName, &err );	/* ̃Gg邩T */
		if( err == RF_OK )
		{
			err = RF_ERR_ALREADY_EXIST;				/* łɓ̃t@C݂ */
		}
		else if( err == RF_ERR_NOT_FOUND )
		{
			/* Ȃ̂łɐVȃGg */
			err = RfmCreateFileEntry( clust, fileName, pFcb );	/* VGg쐬	*/
		}
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        fBNg												*/
/* p[^																*/
/*        dirName : fBNg										*/
/*        pBuff   : I/Op obt@											*/
/*        buffSize: I/Op obt@TCY									*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        VKfBNgB											*/
/*        fBNgɂ͓Ɂu.vu..vfBNg쐬B			*/
/****************************************************************************/
unsigned short RfMkDir( char * fileName )
{
	unsigned short err = RF_ERR_NOT_FREE_FCB;
	unsigned short clust;

	err = RfmIsInitConfirm();								/* 𒲂ׂ */
	if( err == RF_OK )
	{
		clust = RfmGetParentDir( fileName, &err );	/* ŉw̃fBNgNX^ԍ擾 */
		if( err == RF_OK )
		{
			RfmFindFileEntry( clust, fileName, &err ); /* ̃Gg邩T */
			if( err == RF_OK )
			{
				err = RF_ERR_ALREADY_EXIST;			/* łɓ̃t@C݂ */
			}
			else if( err == RF_ERR_NOT_FOUND )
			{
				/* Ȃ̂łɐVȃGg */
				err = RfmCreateDirEntry( clust, fileName );	/* VGg쐬	*/
			}
		}
	}
	return err;
}


/****************************************************************************/
/* T  v																	*/
/*        ݂t@C폜										*/
/* p[^																*/
/*        dirName : t@C											*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        ݂t@C폜B										*/
/*        fBNg͍폜łȂB										*/
/****************************************************************************/
unsigned short RfDelFile( char * fileName )
{
	T_RF_FCB * pFcb = (void*)0UL;
	unsigned long entryAddr = 0UL;
	unsigned short err = RF_ERR_NOT_FREE_FCB;
	unsigned short errRelease = RF_OK;
	unsigned short clust;

	err = RfmIsInitConfirm();							/* 𒲂ׂ */
	if( err != RF_OK )							goto ERR_EXIT;

	pFcb = RfmFindFreeFcb( );							/* FCB ̖gp̈T */

	if( !pFcb )
	{
		err = RF_ERR_NOT_FREE_FCB;
		goto ERR_EXIT;
	}
	err = RfmInitUseFcb( pFcb );					/* FCB  */
	if( err != RF_OK )						goto ERR_EXIT;

	clust = RfmGetParentDir( fileName, &err );		/* ŉw̃fBNgNX^ԍ擾 */
	if( err != RF_OK )						goto ERR_EXIT;
	entryAddr = RfmFindFileEntry( clust, fileName, &err ); /* ̃Gg邩T */
	if( err != RF_OK )						goto ERR_EXIT;
	err = RfmTakeExistInfo( pFcb, entryAddr );		/* fBNg̏ FCB  */
	if( err != RF_OK )						goto ERR_EXIT;
	if( (pFcb->brk.sr.attribute & DIR_ATTR_DIRECTORY ) != 0 )
	{
		err = RF_ERR_DIRECTORY;						/* fBNg͏Ȃ */
		goto ERR_EXIT;
	}
	err = RfmDelFile( &pFcb->brk.df );			/* t@C */

ERR_EXIT:
	if( pFcb )
	{
		errRelease = RfmReleaseFcb( pFcb );		/* FCB J	*/
		if( err == RF_OK )
		{
			err = errRelease;
		}
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        t@C̓ǂݎp𑀍삷								*/
/* p[^																*/
/*        fileName : t@C												*/
/*        add : TRUE ǂݎpɂAFALSE ǂݎpO		*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/****************************************************************************/
unsigned short RfSetReadOnly( char * fileName, unsigned short add )
{
	T_RF_FCB * pFcb = (void*)0UL;
	unsigned long entryAddr = 0UL;
	unsigned short err = RF_ERR_NOT_FREE_FCB;
	unsigned short errRelease = RF_OK;
	unsigned short clust;

	err = RfmIsInitConfirm();						/* 𒲂ׂ */
	if( err != RF_OK )							goto ERR_EXIT;

	pFcb = RfmFindFreeFcb( );						/* FCB ̖gp̈T */

	if( !pFcb )
	{
		err = RF_ERR_NOT_FREE_FCB;
		goto ERR_EXIT;
	}

	err = RfmInitUseFcb( pFcb );					/* FCB  */
	if( err != RF_OK )							goto ERR_EXIT;

	clust = RfmGetParentDir( fileName, &err );		/* ŉw̃fBNgNX^ԍ擾 */
	if( err != RF_OK )							goto ERR_EXIT;
	entryAddr = RfmFindFileEntry( clust, fileName, &err ); /* ̃Gg邩T */
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfmTakeExistInfo( pFcb, entryAddr );		/* fBNg̏ FCB  */
	if( err != RF_OK )							goto ERR_EXIT;
	if( add != FALSE )
	{
		pFcb->brk.sr.attribute |= DIR_ATTR_READ_ONLY;
	}
	else
	{
		pFcb->brk.sr.attribute &= ~DIR_ATTR_READ_ONLY;
	}
	err = RfmUpdateAttr( pFcb );

ERR_EXIT:
	if( pFcb )
	{
		errRelease = RfmReleaseFcb( pFcb );			/* FCB J	*/
		if( err == RF_OK )
		{
			err = errRelease;
		}
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        fBNgƂ̒̃t@CfBNg폜				*/
/* p[^																*/
/*        dirName : fBNg										*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        ݂fBNg폜B									*/
/*        fBNgɃt@C݂Ƃ͂̃t@C폜B	*/
/*        TufBNgÃTufBNgɂt@C݂	*/
/*       Ƃ͂̃t@CB										*/
/*         fBNgɑ݂邷ׂẴt@CB					*/
/*        root fBNg͏ȂB										*/
/****************************************************************************/
unsigned short RfDelDir( char * fileName )
{
	T_RF_FCB * pFcb = (void*)0UL;
	unsigned long entryAddr = 0UL;
	unsigned short err = RF_ERR_NOT_FREE_FCB;
	unsigned short errRelease = RF_OK;
	unsigned short clust;

	err = RfmIsInitConfirm();						/* 𒲂ׂ */
	if( err != RF_OK )							goto ERR_EXIT;

	pFcb = RfmFindFreeFcb( );						/* FCB ̖gp̈T */

	if( !pFcb )
	{
		err = RF_ERR_NOT_FREE_FCB;
		goto ERR_EXIT;
	}

	err = RfmInitUseFcb( pFcb );					/* FCB  */
	if( err != RF_OK )							goto ERR_EXIT;

	clust = RfmGetParentDir( fileName, &err );		/* ŉw̃fBNgNX^ԍ擾 */
	if( err != RF_OK )							goto ERR_EXIT;
	entryAddr = RfmFindFileEntry( clust, fileName, &err ); /* ̃Gg邩T */
	if( err != RF_OK )							goto ERR_EXIT;
	err = RfmTakeExistInfo( pFcb, entryAddr );		/* fBNg̏ FCB  */
	if( err != RF_OK )							goto ERR_EXIT;
	if( ( pFcb->brk.sr.attribute & DIR_ATTR_DIRECTORY ) == 0 )
	{
		err = RF_ERR_NOT_DIRECTORY;					/* fBNgł͂ȂG[ */
		goto ERR_EXIT;
	}

	pFcb->brk.dd.nest = 0;						/* lXgŏ 0 ɂ */
	err = RfmDelDir( pFcb );					/* fBNg폜 */

ERR_EXIT:
	if( pFcb )
	{
		errRelease = RfmReleaseFcb( pFcb );			/* FCB J	*/
		if( err == RF_OK )
		{
			err = errRelease;
		}
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        t@Cړ												*/
/* p[^																*/
/*        dirName : ړ̃fBNg								*/
/*        fileName: ̃t@C										*/
/*        pBuff   : I/Op obt@											*/
/*        buffSize: I/Op obt@TCY									*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*         t@C܂̓fBNgړB							*/
/****************************************************************************/
unsigned short RfMove( char * dirName, char * fileName )
{
	T_RF_FCB * pFcb = NULL;
	unsigned short clust;								/* NX^ԍ	*/
	T_RF_MOVE_INFO	moveInfo;							/* ړ̃p[^	*/
	unsigned short err = RF_OK;							/* G[R[h		*/
	unsigned short errRelease = RF_OK;
	unsigned long entryAddr;							/* fBNgGg̃AhX */

	err = RfmIsInitConfirm();							/* 𒲂ׂ */
	if( err != RF_OK )							goto ERR_EXIT;

	pFcb = RfmFindFreeFcb( );							/* FCB ̖gp̈T */

	if( !pFcb )
	{
		err = RF_ERR_NOT_FREE_FCB;
		goto ERR_EXIT;
	}
	err = RfmInitUseFcb( pFcb );						/* FCB  */
	if( err != RF_OK )					goto ERR_EXIT;

	/* t@C̏擾 */
	clust = RfmGetParentDir( fileName, &err );			/* ŉw̃fBNgNX^ԍ擾 */
	if( err != RF_OK )					goto ERR_EXIT;
	entryAddr = RfmFindFileEntry( clust, fileName, &err ); /* ړ̃t@C肷 */
	if( err != RF_OK )					goto ERR_EXIT;
	err = RfmTakeExistInfo( pFcb, entryAddr );			/* fBNg̏ FCB  */
	if( err != RF_OK )					goto ERR_EXIT;
	moveInfo.orgAttr = pFcb->brk.sr.attribute;			/* t@C̑	*/
	moveInfo.orgEntryAddr = entryAddr;					/* t@CGg̃AhX	*/
	moveInfo.orgCluster = pFcb->brk.sr.firstCluster;	/* t@C̃NX^ʒu		*/

	/* ړ̏擾 */
	clust = RfmGetDirClust( dirName, &err );			/* ړ̃NX^ԍ擾	*/
	if( err != RF_OK )					goto ERR_EXIT;
	entryAddr = RfmFindFileEntry( clust, fileName, &err ); /* ̃Gg邩T */
	if( err == RF_OK )
	{
		err = RF_ERR_ALREADY_EXIST;						/* ̃t@Ĉ݂ňړłȂ */
		goto ERR_EXIT;
	}
	if( err != RF_ERR_NOT_FOUND )		goto ERR_EXIT;	/* ̑̃G[ */
	moveInfo.toCluster = clust;							/* ړfBNg̃NX^ԍ */

	if( (pFcb->brk.sr.attribute & DIR_ATTR_DIRECTORY ) != 0 )
	{
		/* ړ悪ړ̔zɂȂƂ`FbN */
		err = RfmCheckRoots( &moveInfo );
		if( err != RF_OK )				goto ERR_EXIT;
	}

	err = RfmMoveEntry( &moveInfo );					/* ړ	*/

ERR_EXIT:
	if( pFcb )
	{
		errRelease = RfmReleaseFcb( pFcb );			/* FCB J	*/
		if( err == RF_OK )
		{
			err = errRelease;
		}
	}
	return err;
}


/****************************************************************************/
/* T  v																	*/
/*        t@CN[Y											*/
/* p[^																*/
/*        fcbFI[vŎ擾FCB										*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        ɂȂƂ FCB ̊J										*/
/*        write ̏ꍇ͂ɈȉȂ								*/
/*         EFAT 𕨗IɃJ[hɏ									*/
/*         EfBNgXV											*/
/****************************************************************************/
unsigned short RfClose( T_RF_FCB * fcb )
{
	unsigned short err = RF_OK;

	err = RfmIsInitConfirm();						/* 𒲂ׂ */
	if( err == RF_OK )
	{
		err = RfmReleaseFcb( fcb );					/* FCB J	*/
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        f[^ǂݎ													*/
/* p[^																*/
/*        pFcb FI[vŎ擾FCB										*/
/*        pBuffFǂ񂾃f[^i[̈									*/
/*        pLen Fǂݍރf[^TCYi[Ă̈As͎ۂɓ	*/
/*               ߂													*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/****************************************************************************/
unsigned short RfRead( T_RF_FCB * pFcb, char * pBuff, unsigned long * pLen )
{
	return RfmRead( pFcb, pBuff, pLen );
}

/****************************************************************************/
/* T  v																	*/
/*        t@CɃf[^										*/
/* p[^																*/
/*        pFcbFI[vŎ擾FCB										*/
/*        pBuffFރf[^												*/
/*        pSizeFރf[^TCY										*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/****************************************************************************/
unsigned short RfWrite( T_RF_FCB * pFcb, char * pBuff, unsigned long * pLen )
{
	unsigned long remain = *pLen;						/* ݒ */
	unsigned long overWriteLen = 0UL;					/* ㏑钷 */
	unsigned short err = RF_OK;							/* G[R[h	*/

	*pLen = 0UL;

	if( pFcb == NULL )
	{
		return RF_ERR_NOT_OPENED;
	}
	if( pFcb->brk.sr.totalLen > pFcb->brk.sr.curPoint )
	{
		/* ㏑ꍇ͐ɏ㏑ */
		overWriteLen = pFcb->brk.sr.totalLen - pFcb->brk.sr.curPoint;	/* t@C̎c蒷 */
		if( overWriteLen > remain )	overWriteLen = remain;	/* ݂̂قꍇޒɂ */
		err = RfmWriteOver( pFcb, pBuff, &overWriteLen );	/* ㏑ 		*/
		remain -= overWriteLen;							/* c̒XV */
		*pLen = overWriteLen;							/* 񂾒 */
		pBuff += overWriteLen;							/* f[^̎oʒuXV */
	}
	if( ( remain != 0UL ) && ( err == RF_OK ) )
	{
		/* ǉ̏ */
		err = RfmWriteAppend( pFcb, pBuff, &remain );
		*pLen += remain;								/* ǉ݂Z */
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        t@C̓ǂݏ̈ʒuύX								*/
/* p[^																*/
/*        pFcbFI[vŎ擾FCB										*/
/*        offsetForigin̋											*/
/*        originFړ̊Jn_												*/
/*                RF_SEEK_SETFt@C̐擪								*/
/*                RF_SEEK_CURF݈ʒu										*/
/*                RF_SEEK_ENDFt@C̏I[								*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/****************************************************************************/
unsigned short RfSeek( T_RF_FCB * pFcb, long offset, unsigned short origin )
{
	return RfmSeek( pFcb, offset, origin );
}

/****************************************************************************/
/* T  v																	*/
/*        obt@𕨗IɏށB										*/
/* p[^																*/
/*        pFcbFI[vŎ擾FCB										*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        obt@̊JBύXĂobt@͕IɏށBύX	*/
/*        Ȃ̂̂Ŏ̓ǂݎ莞͕IȃANZX	*/
/*        B																*/
/****************************************************************************/
unsigned short RfFlush( T_RF_FCB * pFcb )
{
	unsigned short errCode = RF_ERR_NOT_OPENED;

	if( pFcb != NULL )
	{
		if( pFcb->useFlag != FALSE )
		{
			errCode = RfmFlush( pFcb );
		}
	}
	return errCode;
}

/****************************************************************************/
/* T  v																	*/
/*        I[vꂽt@C̒擾							*/
/* p[^																*/
/*        pFcbFI[vŎ擾FCB										*/
/*        sizeFt@Ci[̈									*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        炩߃t@C̓I[vĂȂ΂ȂȂBI[v	*/
/*       [h͓ɖȂBfBNgw肳ꂽꍇ̓G[B		*/
/****************************************************************************/
unsigned short RfGetSize( T_RF_FCB * pFcb, unsigned long * size )
{
	unsigned short err = RF_ERR_NOT_OPENED;

	if( pFcb != NULL )
	{
		if( pFcb->useFlag != FALSE )
		{
			if( (pFcb->brk.sr.attribute & DIR_ATTR_DIRECTORY) == 0 )
			{
				*size = pFcb->brk.sr.totalLen;
				err = RF_OK;
			}
			else
			{
				err = RF_ERR_DIRECTORY;
			}
		}
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        t@CVXẽo[W擾							*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_DEFINE_DRIVERFhCo@\`							*/
/*   																	*/
/*        o[Wԍ擾											*/
/****************************************************************************/
unsigned short RfGetVerSion( T_RF_FSYS_VER * fsysVer )
{
	unsigned short success = RF_ERR_DEFINE_DRIVER;

	fsysVer->fsys = RF_FILESYSTEM_VERSION;				/* t@CVXeo[W */
	if( rfDriverInterface.getVer != NULL )
	{
		drvGetVer( &fsysVer->drv );						/* hCoo[W擾 */
		success = RF_OK;
	}
	return success;
}

/****************************************************************************/
/* T  v																	*/
/*        fBNgI[v										*/
/* p[^																*/
/*        fileNameFt@C												*/
/*        pErr    FG[R[hi[̈ւ̃|C^					*/
/* ߂l																	*/
/*        T_RF_FCB \̂ւ̃|C^										*/
/*        NULL ̎̓G[													*/
/*   																	*/
/****************************************************************************/
T_RF_FCB * RfOpenDir( char * fileName, unsigned short * pErr )
{
	T_RF_FCB * pFcb = (void*)0UL;
	unsigned long entryAddr = 0UL;
	unsigned short clust;

	*pErr = RfmIsInitConfirm();						/* 𒲂ׂ */
	if( *pErr != RF_OK )						goto ERR_EXIT;

	pFcb = RfmFindFreeFcb( );						/* FCB ̖gp̈T */

	if( pFcb == NULL )
	{
		*pErr = RF_ERR_NOT_FREE_FCB;
		goto ERR_EXIT;
	}

	*pErr = RfmInitUseFcb( pFcb );					/* FCB  */
	if( *pErr != RF_OK )						goto ERR_EXIT;

	clust = RfmGetParentDir( fileName, pErr );		/* ŉw̃fBNgNX^ԍ擾 */
	if( *pErr == RF_ERR_ROOT_DIRECTORY )
	{
		/* [gfBNg̎ */
		*pErr = RfmTakeRootInfo( pFcb );
		if( *pErr != RF_OK )						goto ERR_EXIT;
	}
	else
	{
		/* TufBNg̎ */
		entryAddr = RfmFindFileEntry( clust, fileName, pErr ); /* ̃Gg邩T */
		if( *pErr != RF_OK )						goto ERR_EXIT;
		*pErr = RfmTakeExistInfo( pFcb, entryAddr );		/* fBNg̏ FCB  */
		if( *pErr != RF_OK )						goto ERR_EXIT;
		if( ( pFcb->brk.sd.attribute & DIR_ATTR_DIRECTORY ) == 0 )
		{
			*pErr = RF_ERR_NOT_DIRECTORY;					/* fBNgł͂ȂG[ */
			goto ERR_EXIT;
		}
	}
	pFcb->openMode = RF_OPEN_DIR;			/* fBNgƂăI[v */
	pFcb->brk.sr.pointInCluster = 0UL;			/* NX^̈ʒu擪 */

ERR_EXIT:
	if( ( *pErr != RF_OK ) && ( pFcb != NULL ) )
	{
		/* G[ */
		pFcb->useFlag = FALSE;							/* gȂ̂ 0 ɖ߂ */
		pFcb = NULL;
	}
	return pFcb;
}

/****************************************************************************/
/* T  v																	*/
/*        fBNgǂ												*/
/* p[^																*/
/*        pFcb    FRfOpenDir() ̖߂l									*/
/*        pDirInfoFǂݍ񂾃fBNg								*/
/* ߂l																	*/
/*        RF_OK ͐														*/
/*        RF_ERR_...̓G[												*/
/*   																	*/
/****************************************************************************/
unsigned short RfReadDir( T_RF_FCB * pFcb, T_RF_DIR_INFO * pDirInfo )
{
	unsigned short err = RF_ERR_NOT_OPEN_DIR;

	if( pFcb->openMode == RF_OPEN_DIR )			/* fBNgƂăI[v */
	{

		err = RfmReadDir( pFcb, pDirInfo );
	}
	
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        fBNgI[v										*/
/* p[^																*/
/*        fileNameFt@C												*/
/*        pErr    FG[R[hi[̈ւ̃|C^					*/
/* ߂l																	*/
/*        T_RF_FCB \̂ւ̃|C^										*/
/*        NULL ̎̓G[													*/
/*   																	*/
/****************************************************************************/
unsigned short RfCloseDir( T_RF_FCB * pFcb  )
{
	return RfmReleaseFcb( pFcb );				/* FCB J	*/
}

