/****************************************************************************/
/* T  vF t@CVXe directory 폜eXgpt@C					*/
/*   F 																*/
/* 쐬F 2005.06.19														*/
/* XVF 2014.02.15														*/
/* Copyright    resove														*/
/****************************************************************************/

/*#include <stdio.h> */
#include "RfInterface.h"
#include "TraceOut.h"
#include "TstWriteVal.h"
#include "TstDefine.h"
#include "TstGeneral.h"
#include "TstWriteFunc.h"

#define	TEST_FILE_NAME			"sub\\large.txt"
#define	TEST_ROOT_FILE_NAME		"root.txt"
#define MANY_NUM				( 5 )

/****************************************************************************/
/* T  v																	*/
/*        eXgf[^ăfBNg폜̃eXgs			*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestDelDir( void )
{
	unsigned short err;

	TEST_TITLE(("Test delete directory."));
	TestReady();
	
	err = RfMkDir( "\\sub1" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\\sub1)");
	err = RfMkDir( "\\sub1\\sub2" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\\sub2)");
	err = RfMkDir( "\\sub1\\sub2\\sub3" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\\sub3)");
	err = RfMkDir( "\\sub1\\sub2\\sub3\\sub4" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\\sub4)");
	err = RfMkDir( "\\sub1\\sub2\\sub3\\sub4\\sub5" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\\sub5)");


	err = RfMkDir( "\\subb1" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\\subb1)");
	err = RfMkDir( "\\subb1\\subb2" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\\subb2)");

	TestWriteSmallFile("\\sub1\\aaa11.txt" );			/* write(sub1\aaa11.txt) */
	TestWriteSmallFile("\\sub1\\aaa12.txt" );			/* write(sub1\aaa12.txt) */

	TestWriteSmallFile("\\sub1\\sub2\\aaa21.txt" );		/* write(sub1\sub2\aaa21.txt) */
	TestWriteSmallFile("\\sub1\\sub2\\aaa22.txt" );		/* write(sub1\sub2\aaa22.txt) */
	TestWriteSmallFile("\\sub1\\sub2\\aaa23.txt" );		/* write(sub1\sub2\aaa23.txt) */

	err = RfMkDir( "\\sub1\\sub2\\sub3" );

	TestWriteSmallFile("\\sub1\\sub2\\sub3\\aaa31.txt" );/* write(sub1\sub2\sub3\aaa31.txt) */
	TestWriteMany("\\sub1\\sub2\\sub3\\bbb", MANY_NUM);	/* 񏑂 */

	TestWriteSmallFile("\\root.txt" );					/* write(root.txt) */

	/* delete dir */
	err = RfDelDir( "\\sub1" );
	CHK_ERR_CODE(err, RF_OK, "RfDelDir()");

	err = RfDelDir( "\\subb1\\subb2\\" );				/* \ Ōɕt */
	CHK_ERR_CODE(err, RF_OK, "RfDelDir()");

	err = RfDelDir( "\\" );
	CHK_ERR_CODE(err, RF_ERR_ROOT_DIRECTORY, "RfDelDir()[NG]");	/* root ͏ȂG[ɂȂ */

	TestConclude();
}

