/****************************************************************************/
/* T  vF flush ̃eXg													*/
/*   F flush ̃eXg													*/
/* 쐬F 2011.07.24														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "RfInterface.h"
#include "TraceOut.h"
#include "TstWriteVal.h"
#include "TstDefine.h"

typedef struct t_buff_ctrl_unify
{
	T_RF_FILE_BUFF *buffCtrl;				/* obt@Ǘ̈zւ̃|C^	*/
	unsigned short buffNum;					/* obt@			*/
	char canWriteFlag:1;					/* write \tO	*/
	char fill;								/* 				*/
} T_BUFF_CTRL_UNIFY;
extern T_BUFF_CTRL_UNIFY buffCtrlUnify;			/* FATobt@܂Ƃ	*/

#define BUFF_NUM_LIM (10)

/****************************************************************************/
/* T  v																	*/
/*        flush s̃obt@̎gp󋵂mF						*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestFlush( void )
{
	T_RF_FCB *pFcb;
	unsigned short err = RF_OK;
	unsigned long len = 0L;
	int i = 0;
	unsigned short okCount;
	

	TEST_TITLE(("Test flush"));
	TestReady();

	pFcb = RfOpen( "\\flushtst.TXT", RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen()");
	if( err != RF_OK )							goto ERR_EXIT;
	len = 14L;
	err = RfWrite( pFcb, "Before Flush.\n", &len);
	CHK_ERR_CODE(err, RF_OK, "RfWrite()");

	err = RfFlush( pFcb );
	CHK_ERR_CODE(err, RF_OK, "RfFlush()");

	/* RfFlush() ̃obt@ */
	okCount = 0;
	for( i = 0; i < buffCtrlUnify.buffNum; i++ )
	{
		if(buffCtrlUnify.buffCtrl[i].updateFlag == FALSE )
		{
			okCount++;
		}
	}
	CHK_CMP_DEC(okCount, buffCtrlUnify.buffNum, "empty Buffer num.");
	len = 13L;
	err = RfWrite( pFcb, "After Flush.\n", &len);
	CHK_ERR_CODE(err, RF_OK, "RfWrite()");

	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "RfClose()");

	/* RfClose() ̃obt@ */
	okCount = 0;
	for( i = 0; i < buffCtrlUnify.buffNum; i++ )
	{
		if(buffCtrlUnify.buffCtrl[i].updateFlag == FALSE )
		{
			okCount++;
		}
	}
	CHK_CMP_DEC(okCount, buffCtrlUnify.buffNum, "empty Buffer num.");

ERR_EXIT:
	TestConclude();
	return;
}

